var jsversion=23;
/*******************************
* KeyCombo object stores a key combo, including the int value and booleans for control/shift/alt
*******************************/
(function  () {

	var moduleName = "KeyCombo"; // constructor
	var instanceCount = 0;

	// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
	var module = window[moduleName] = Module;
	
	//constructor
	//function Module (fooo1,fooo2=false,fooo3=false,fooo4=false) {
	function Module (ikeyval,bcontrol=false,bshift=false,balt=false) {
		/// PRIVATE INSTANCE VARIABLES	
		
		///PUBLIC METHODS
		this.keyval = ikeyval;
		this.control = bcontrol;
		this.shift = bshift;
		this.alt = balt;
		this.equals = equals;
		this.itoe = itoe;
		this.itoeShort = itoeShort;
		this.etoi = etoi;
		this.unset = unset;
		this.isused = isused;
	} // KeyCombo Module constructor
	
	// equals compares to some other keycombo passed in
	function equals(kc){
		let ret = false;
		if( kc.keyval != this.keyval ) return false;
		if(kc.control===this.control && kc.shift===this.shift && kc.alt===this.alt) return true;
		return false;
	}//equals
	
	function unset(){this.keyval=-1;this.control=false;this.shift=false;this.alt=false;}
	function isused(){return(this.keyval==-1 ? false : true);}
	
	function itoe(){
		let sfoo = "";
		if(this.keyval == -1) return( sfoo );
		if(this.control ) sfoo = (sfoo=="") ? sfoo += "Control" : sfoo+="-Ctrl";
		if(this.shift ) sfoo = (sfoo=="") ? sfoo += "Shift" : sfoo+="-Shift";
		if(this.alt )  sfoo = (sfoo=="") ? sfoo += "Alt" : sfoo+="-Alt";
		sfoo = (sfoo=="") ? sfoo+=KSMAP.get(this.keyval) : sfoo+=("-"+KSMAP.get(this.keyval)) ;
		return(sfoo);
	}
	
	//special character glyphs below from:
	//https://apple.stackexchange.com/questions/55727/where-can-i-find-the-unicode-symbols-for-mac-functional-keys-command-shift-e
	function itoeShort(){ //this is for the menu item display
		let sfoo = "";
		if(this.keyval == -1) return( sfoo );
		if(this.control ) sfoo = (sfoo=="") ? sfoo += "^" : sfoo+="^";
		//if(this.shift ) sfoo = (sfoo=="") ? sfoo += "⇧" : sfoo+="⇧";
		if(this.shift ) sfoo = (sfoo=="") ? sfoo += "&#8679;" : sfoo+="&#8679;";
		//if(this.alt )  sfoo = (sfoo=="") ? sfoo += "⌥" : sfoo+="⌥";
		if(this.alt )  sfoo = (sfoo=="") ? sfoo += "&#8997;" : sfoo+="&#8997;";
		sfoo = (sfoo=="") ? sfoo+=KSMAPSHORT.get(this.keyval) : sfoo+=(" "+KSMAPSHORT.get(this.keyval)) ;
		return(sfoo);
	}
	
	function etoi(s){
		if( s=="" ){
			this.keyval = -1;
			this.control = false;
			this.shift = false;
			this.alt = false;
		} else {
			//assume unused and go from there
			this.keyval = -1;
			this.control = false;
			this.shift = false;
			this.alt = false;

			let sfoo1 = s;
			let sfoo2 = sfoo1.split("-");
			let slen = sfoo2.length;
			let sfoo3 = ""
			let ifoo = 0;
			for( let i=0; i<slen; i++ ){
				sfoo3 = sfoo2[i];
				switch(sfoo3){
					case "Control":
						this.control = true
						break;
					case "Shift":
						this.shift = true
						break;
					case "Alt":
						this.alt = true
						break;
					default: //must be a key, so look it up in the reversed map
						ifoo = KSMAP_R.get(sfoo3);
						this.keyval = KSMAP_R.get(sfoo3);
				}//switch
			}//for
		}
		return(this);
		//return(new KeyCombo(_ikeyval,	_bcontrol,	_bshift,	_balt) );
	}
}) (); // KeyCombo


///////////////////////////////////

var prefsTabSet = null;


function alertClose(){
	myAlertDialog.close();
	console.log("alertClose: firstCollisionId=",firstCollisionId);
	let sfoo="#"+firstCollisionId;
	$(sfoo).focus()
}


$("#content").on("click", "[role='tablist'] button", function(e) {
	debug("tab [" + $(this).text().trim()+"] clicked")

	//e.preventDefault();
  
    if( $(this).text().trim()=="Shortcuts" ){
    	//debug("REMOVE normal keydown handler, ADD keydown handler for setting shortcuts");
		$(document).off("keydown", __editor.table.windowKeyDownHandler);
		$(".skfield").off("keydown", keyhandlerSetShortcut);
		$(".skfield").on("keydown", keyhandlerSetShortcut);

    } else if( $(this).text().trim()=="General" ){
    	//debug("REMOVE keydown handler for setting shortcuts, ADD normal keydown handler");
		$(".skfield").off("keydown", keyhandlerSetShortcut);
		$(document).off("keydown", __editor.table.windowKeyDownHandler);
		$(document).on("keydown", __editor.table.windowKeyDownHandler);
    }
});

function resetTabs(){
	$($(".tabs > li > a")[0]).trigger("click"); //click on first one
}

///////////////////////////////////

function somefunc(){
	console.log("somefunc called");
}

function setShortcutField(which){
	let sfoo = which;
	let o$ = $("#"+which);
	switch(which) {
	  //FILE
	  case FILE_NewProject:
	    o$.text( SKMAP_DEFAULTS.get(FILE_NewProject)  );
	    break;
	  case FILE_OpenProject:
	    o$.text( SKMAP_DEFAULTS.get(FILE_OpenProject) );
	    break;
	  case FILE_SaveProject:
	    o$.text( SKMAP_DEFAULTS.get(FILE_SaveProject) );
	    break;
	  case FILE_SaveProjectAs:
	    o$.text( SKMAP_DEFAULTS.get(FILE_SaveProjectAs) );
	    break;
	  case FILE_OpenMedia:
	    o$.text( SKMAP_DEFAULTS.get(FILE_OpenMedia) );
	    break;
	  case FILE_OpenURL:
	    o$.text( SKMAP_DEFAULTS.get(FILE_OpenURL) );
	    break;
	  case FILE_Import :
	    o$.text( SKMAP_DEFAULTS.get(FILE_Import) );
	    break;
	  case FILE_Export :
	    o$.text( SKMAP_DEFAULTS.get(FILE_Export) );
	    break;
	  case FILE_Quit:
	    o$.text( SKMAP_DEFAULTS.get(FILE_Quit) );
	    break;
	    
	  //EDIT
	  case EDIT_CutBlock:
	    o$.text( SKMAP_DEFAULTS.get(EDIT_CutBlock) );
	    break;
	  case EDIT_CopyBlock:
	    o$.text( SKMAP_DEFAULTS.get(EDIT_CopyBlock) );
	    break;
	  case EDIT_PasteBlock:
	    o$.text( SKMAP_DEFAULTS.get(EDIT_PasteBlock) );
	    break;
	  case EDIT_DeleteBlock:
	    o$.text( SKMAP_DEFAULTS.get(EDIT_DeleteBlock) );
	    break;
	  case EDIT_WrapToRuler:
	    o$.text( SKMAP_DEFAULTS.get(EDIT_WrapToRuler) );
	    break;
	  case EDIT_Find:
	    o$.text( SKMAP_DEFAULTS.get(EDIT_Find) );
	    break;
	    
	  //STYLE
	  case STYLE_Bold:
	    o$.text( SKMAP_DEFAULTS.get(STYLE_Bold) );
	    break;
	  case STYLE_Italic:
	    o$.text( SKMAP_DEFAULTS.get(STYLE_Italic) );
	    break;
	  case STYLE_Underline:
	    o$.text( SKMAP_DEFAULTS.get(STYLE_Underline) );
	    break;
	  case STYLE_MusicalNote:
	    o$.text( SKMAP_DEFAULTS.get(STYLE_MusicalNote) );
	    break;
	    
	  //EVENTS
	  case EVENTS_GoToCurrentRow:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_GoToCurrentRow) );
	    break;
	  case EVENTS_InsertRowBefore:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_InsertRowBefore) );
	    break;
	  case EVENTS_InsertRowAfter:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_InsertRowAfter) );
	    break;
	  case EVENTS_CombineRowUp:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_CombineRowUp) );
	    break;
	  case EVENTS_DeleteRows:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_DeleteRows) );
	    break;
	  case EVENTS_ClearEditor:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_ClearEditor) );
	    break;
	  case EVENTS_ClearCurrentTimes:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_ClearCurrentTimes) );
	    break;
	  case EVENTS_ClearAllTimes:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_ClearAllTimes) );
	    break;
	  case EVENTS_ClearEndTimes:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_ClearEndTimes) );
	    break;
	  case EVENTS_InsertStartTime:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_InsertStartTime) );
	    break;
	  case EVENTS_InsertEndTime:
	    o$.text( SKMAP_DEFAULTS.get(EVENTS_InsertEndTime) );
	    break;
	    
	  //PLAYER
	  case PLAYER_PlayPause:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PlayPause) );
	    break;
	  case PLAYER_PlayPauseAD:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PlayPauseAD) );
	    break;
	  case PLAYER_Stop:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_Stop) );
	    break;
	  case PLAYER_PlayDirect:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PlayDirect) );
	    break;
	  case PLAYER_PauseDirect:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PauseDirect) );
	    break;
	  case PLAYER_CueToStartTime:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_CueToStartTime) );
	    break;
	  case PLAYER_CueToEndTime:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_CueToEndTime) );
	    break;
	  case PLAYER_SyncToPlayer:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_SyncToPlayer) );
	    break;
	  case PLAYER_PlaySlower:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PlaySlower) );
	    break;
	  case PLAYER_PlayFaster:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PlayFaster) );
	    break;
	  case PLAYER_PlayNormal:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_PlayNormal) );
	    break;
	  case PLAYER_ScrubBackSmall:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_ScrubBackSmall) );
	    break;
	  case PLAYER_ScrubBackMedium:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_ScrubBackMedium) );
	    break;
	  case PLAYER_ScrubBackLarge:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_ScrubBackLarge) );
	    break;
	  case PLAYER_ScrubForwardSmall:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_ScrubForwardSmall) );
	    break;
	  case PLAYER_ScrubForwardMedium:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_ScrubForwardMedium) );
	    break;
	  case PLAYER_ScrubForwardLarge:
	    o$.text( SKMAP_DEFAULTS.get(PLAYER_ScrubForwardLarge) );
	    break;
	    
	  //TOOLS
	  case TOOLS_CheckTimecodes:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_CheckTimecodes) );
	    break;
	  case TOOLS_OffsetTimecodes:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_OffsetTimecodes) );
	    break;
	  case TOOLS_CheckCEA608:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_CheckCEA608) );
	    break;
	  case TOOLS_ShowRuler:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_ShowRuler) );
	    break;
	  case TOOLS_ShowWaveform:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_ShowWaveform) );
	    break;
	  case TOOLS_PresentationMode:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_PresentationMode) );
	    break;
	  case TOOLS_PresentationModeNoCC:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_PresentationModeNoCC) );
	    break;
	  case TOOLS_ConvertToDescriptions:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_ConvertToDescriptions) );
	    break;
	  case TOOLS_Preferences:
	    o$.text( SKMAP_DEFAULTS.get(TOOLS_Preferences) );
	    break;
	    
	  //HELP
	  case HELP_CadetHelp:
	    o$.text( SKMAP_DEFAULTS.get(HELP_CadetHelp) );
	    break;
	  case HELP_CadetUserForum:
	    o$.text( SKMAP_DEFAULTS.get(HELP_CadetUserForum) );
	    break;
	  case HELP_KeyboardShortcuts:
	    o$.text( SKMAP_DEFAULTS.get(HELP_KeyboardShortcuts) );
	    break;
	  case HELP_AboutCadet:
	    o$.text( SKMAP_DEFAULTS.get(HELP_AboutCadet) );
	    break;
	  
	  //MISC
	  case MISC_MoveUpRow:
	    o$.text( SKMAP_DEFAULTS.get(MISC_MoveUpRow) );
	    break;
	  case MISC_MoveDownRow:
	    o$.text( SKMAP_DEFAULTS.get(MISC_MoveDownRow) );
	    break;
	  case MISC_MoveUpRowExtendBlock:
	    o$.text( SKMAP_DEFAULTS.get(MISC_MoveUpRowExtendBlock) );
	    break;
	  case MISC_MoveDownRowExtendBlock:
	    o$.text( SKMAP_DEFAULTS.get(MISC_MoveDownRowExtendBlock) );
	    break;
	  case MISC_ToggleEditReviewMode:
	    o$.text( SKMAP_DEFAULTS.get(MISC_ToggleEditReviewMode) );
	    break;
	  case MISC_ToggleCCADMode:
	    o$.text( SKMAP_DEFAULTS.get(MISC_ToggleCCADMode) );
	    break;
	  case MISC_ADInsertTimeAsComment:
	    o$.text( SKMAP_DEFAULTS.get(MISC_ADInsertTimeAsComment) );
	    break;
	  case MISC_ToggleActivateMenuBar:
	    o$.text( SKMAP_DEFAULTS.get(MISC_ToggleActivateMenuBar) );
	    break;



	  default:
	    // code block
	}
}

function setAllDefaults(){
	//FILE
	setShortcutField(FILE_NewProject);
	setShortcutField(FILE_OpenProject);
	setShortcutField(FILE_SaveProject);
	setShortcutField(FILE_SaveProjectAs);
	setShortcutField(FILE_OpenMedia);
	setShortcutField(FILE_OpenURL);
	setShortcutField(FILE_Import);
	setShortcutField(FILE_Export);
	setShortcutField(FILE_Quit);
	//EDIT
	setShortcutField(EDIT_CutBlock);
	setShortcutField(EDIT_CopyBlock);
	setShortcutField(EDIT_PasteBlock);
	setShortcutField(EDIT_DeleteBlock);
	setShortcutField(EDIT_WrapToRuler);
	setShortcutField(EDIT_Find);
	//STYLE
	setShortcutField(STYLE_Bold);
	setShortcutField(STYLE_Italic);
	setShortcutField(STYLE_Underline);
	setShortcutField(STYLE_MusicalNote);
	//EVENTS
	setShortcutField(EVENTS_GoToCurrentRow);
	setShortcutField(EVENTS_InsertRowBefore);
	setShortcutField(EVENTS_InsertRowAfter);
	setShortcutField(EVENTS_CombineRowUp);
	setShortcutField(EVENTS_DeleteRows);
	setShortcutField(EVENTS_ClearEditor);
	setShortcutField(EVENTS_ClearCurrentTimes);
	setShortcutField(EVENTS_ClearAllTimes);
	setShortcutField(EVENTS_ClearEndTimes);
	setShortcutField(EVENTS_InsertStartTime);
	setShortcutField(EVENTS_InsertEndTime);
	//PLAYER
	setShortcutField(PLAYER_PlayPause);
	setShortcutField(PLAYER_PlayPauseAD);
	setShortcutField(PLAYER_Stop);
	setShortcutField(PLAYER_PlayDirect);
	setShortcutField(PLAYER_PauseDirect);
	setShortcutField(PLAYER_CueToStartTime);
	setShortcutField(PLAYER_CueToEndTime);
	setShortcutField(PLAYER_SyncToPlayer);
	setShortcutField(PLAYER_PlaySlower);
	setShortcutField(PLAYER_PlayFaster);
	setShortcutField(PLAYER_PlayNormal);
	setShortcutField(PLAYER_ScrubBackSmall);
	setShortcutField(PLAYER_ScrubBackMedium);
	setShortcutField(PLAYER_ScrubBackLarge);
	setShortcutField(PLAYER_ScrubForwardSmall);
	setShortcutField(PLAYER_ScrubForwardMedium);
	setShortcutField(PLAYER_ScrubForwardLarge);
	//TOOLS
	setShortcutField(TOOLS_CheckTimecodes);
	setShortcutField(TOOLS_OffsetTimecodes);
	setShortcutField(TOOLS_CheckCEA608);
	setShortcutField(TOOLS_ShowRuler);
	setShortcutField(TOOLS_ShowWaveform);
	setShortcutField(TOOLS_PresentationMode);
	setShortcutField(TOOLS_PresentationModeNoCC);
	setShortcutField(TOOLS_ConvertToDescriptions);
	setShortcutField(TOOLS_Preferences);
	//HELP
	setShortcutField(HELP_CadetHelp);
	setShortcutField(HELP_CadetUserForum);
	setShortcutField(HELP_KeyboardShortcuts);
	setShortcutField(HELP_AboutCadet);
	//MISC
	setShortcutField(MISC_MoveUpRow);
	setShortcutField(MISC_MoveDownRow);
	setShortcutField(MISC_MoveUpRowExtendBlock);
	setShortcutField(MISC_MoveDownRowExtendBlock);
	setShortcutField(MISC_ToggleEditReviewMode);
	setShortcutField(MISC_ToggleCCADMode);
	setShortcutField(MISC_ADInsertTimeAsComment);
	setShortcutField(MISC_ToggleActivateMenuBar);

}

function unsetAll(){
	var myfields = 	$(".skfield")
	/**/
	for (let index = 0; index < myfields.length; ++index) {
		var fld = myfields[index];
		$(fld).text("");
	}	
}
function errorAll(){
		$("span.shortcuterror").removeClass("hide");
}
function errorNone(){
		$("span.shortcuterror").addClass("hide");
}


function keyhandlerSetShortcut(e){

	//TAB/ESC/COMMAND not captured
	if(e.keyCode==9 || e.keyCode==27 || e.keyCode==91 ){
		//debug("TAB/ESC/COMMAND shortcut not allowed");
		console.log("TAB/ESC/COMMAND shortcut not allowed, bubbling");
		return;

	} else if(e.keyCode >= 8 && e.keyCode <= 222){
		//meta keys not captured
		if( e.keyCode==16 || e.keyCode==17 || e.keyCode==18) return;	//skip meta keys but keep going
		if( e.keyCode==20 ) return(false); //skip CAPS LOCK key
		
		//ENTER key
		if( e.keyCode==13 && !e.ctrlKey && !e.shiftKey && !e.altlKey ){
			console("Unadorned ENTER shortcut not allowed");
			e.preventDefault();
			return(false) ; //skip unadorned ENTER key do not bubble or anything
		}
		
		//skip unadorned (or only shifted) alphanumerics
		//skip unadorned arrow keys and others
		/*
		48-90 == 0-9, A-Z       186-222 == other punctuation, etc.
		[96,	"Num0"],
		[97,	"Num1"],
		[98,	"Num2"],
		[99,	"Num3"],
		[100,	"Num4"],
		[101,	"Num5"],
		[102,	"Num6"],
		[103,	"Num7"],
		[104,	"Num8"],
		[105,	"Num9"],
		[106,	"NumAsterisk"],
		[107,	"NumPlus"],
		[109,	"NumHyphen"],
		[110,	"NumPeriod"],
		[111,	"NumForwardSlash"],
		*/
		if( ( (e.keyCode >= 48 && e.keyCode <= 90) || (e.keyCode >= 96 && e.keyCode <= 111)|| (e.keyCode >= 186 && e.keyCode <= 222) ) && (!e.ctrlKey && !e.altlKey) ){
			e.preventDefault();
			return(false);
		}
		
		//skip unadorned arrow keys and others
		/*
		[8,		"BackDelete"],
		[12,	"NumClear"],
		[13,	"Enter"],
		[20,	"CapsLock"],
		[27,	"Esc"],
		[32,	"Space"],
		[33,	"PageUp"],
		[34,	"PageDown"],
		[35,	"End"],
		[36,	"Home"],
		[37,	"LeftArrow"],
		[38,	"UpArrow"],
		[39,	"RightArrow"],
		[40,	"DownArrow"],
		[46,	"ForwardDelete"],
		*/
		if( ( (e.keyCode >= 37 && e.keyCode <= 40) || (e.keyCode == 8 
														|| e.keyCode == 12 
														|| e.keyCode == 20 
														|| e.keyCode == 32 
														|| e.keyCode == 33 
														|| e.keyCode == 34 
														|| e.keyCode == 35 
														|| e.keyCode == 36 
														|| e.keyCode == 46) )
				 && (!e.ctrlKey && !e.altlKey) ){
			e.preventDefault();
			return(false);
		}


		
		console.log("inside KSMAP range");
		//create the current keydown key combo
		let kc = new KeyCombo(e.keyCode, e.ctrlKey, e.shiftKey, e.altKey);
		$(this).text( kc.itoe() );
		somefunc();
		e.preventDefault();
		return;


	} else {
		console.log("other");
		e.preventDefault();
		return;
	}
}

//CONSTANTS
let	FILE_NewProject = "fileNewProject",
	FILE_OpenProject = "fileOpenProject",
	FILE_SaveProject = "fileSaveProject",
	FILE_SaveProjectAs = "fileSaveProjectAs",
	FILE_OpenMedia = "fileOpenMedia",
	FILE_OpenURL = "fileOpenUrl",
	FILE_Import = "fileImport",
	FILE_Export = "fileExport",
	FILE_Quit = "fileQuit",
	
	EDIT_CutBlock = "editCutBlock",
	EDIT_CopyBlock = "editCopyBlock",
	EDIT_PasteBlock = "editPasteBlock",
	EDIT_DeleteBlock = "editDeleteBlock",
	EDIT_WrapToRuler = "editWrapToRuler",
	EDIT_Find = "editFind",
	
	STYLE_Bold = "styleBold",
	STYLE_Italic = "styleItalic",
	STYLE_Underline = "styleUnderline",
	STYLE_MusicalNote = "styleMusicalNote",
	STYLE_AlignLeft = "styleAlignLeft",
	STYLE_AlignCenter = "styleAlignCenter",
	STYLE_AlignRight = "styleAlignRight",
	STYLE_AlignTop = "styleAlignTop",
	STYLE_AlignMiddle = "styleAlignMiddle",
	STYLE_AlignBottom = "styleAlignBottom",
	STYLE_TextColorBlack = "styleTextColorBlack",
	STYLE_TextColorWhite = "styleTextColorWhite",
	STYLE_TextColorRed = "styleTextColorRed",
	STYLE_TextColorBlue = "styleTextColorBlue",
	STYLE_TextColorGreen = "styleTextColorGreen",
	STYLE_TextColorYellow = "styleTextColorYellow",
	STYLE_TextColorCyan = "styleTextColorCyan",
	STYLE_TextColorMagenta = "styleTextColorMagenta",
	STYLE_BackgroundColorBlack = "styleBackgroundColorBlack",
	STYLE_BackgroundColorWhite = "styleBackgroundColorWhite",
	STYLE_BackgroundColorRed = "styleBackgroundColorRed",
	STYLE_BackgroundColorBlue = "styleBackgroundColorGreen",
	STYLE_BackgroundColorGreen = "styleBackgroundColorBlue",
	STYLE_BackgroundColorYellow = "styleBackgroundColorYellow",
	STYLE_BackgroundColorCyan = "styleBackgroundColorCyan",
	STYLE_BackgroundColorMagenta = "styleBackgroundColorMagenta",
	
	EVENTS_GoToCurrentRow = "eventsGoToCurrentRow",
	EVENTS_InsertRowBefore = "eventsInsertRowBefore",
	EVENTS_InsertRowAfter = "eventsInsertRowAfter",
	EVENTS_CombineRowUp = "eventsCombineRowUp",
	EVENTS_DeleteRows = "eventsDeleteRows",
	EVENTS_ClearEditor = "eventsClearEditor",
	EVENTS_ClearCurrentTimes = "eventsClearCurrentTimes",
	EVENTS_ClearAllTimes = "eventsClearAllTimes",
	EVENTS_ClearEndTimes = "eventsClearEndTimes",
	EVENTS_InsertStartTime = "eventsInsertStartTime",
	EVENTS_InsertEndTime = "eventsInsertEndTime",
	
	PLAYER_PlayPause = "playerPlayPause",
	PLAYER_PlayPauseAD = "playerPlayPauseAD",
	PLAYER_Stop = "playerStop",
	PLAYER_PlayDirect = "playerPlayDirect",
	PLAYER_PauseDirect = "playerPauseDirect",
	PLAYER_CueToStartTime = "playerCueToStartTime",
	PLAYER_CueToEndTime = "playerCueToEndTime",
	PLAYER_SyncToPlayer = "playerSyncToPlayer",
	PLAYER_PlaySlower = "playerPlaySlower",
	PLAYER_PlayFaster = "playerPlayFaster",
	PLAYER_PlayNormal = "playerPlayNormal",
	PLAYER_ScrubBackSmall = "playerScrubBackSmall",
	PLAYER_ScrubBackMedium = "playerScrubBackMedium",
	PLAYER_ScrubBackLarge = "playerScrubBackLarge",
	PLAYER_ScrubForwardSmall = "playerScrubForwardSmall",
	PLAYER_ScrubForwardMedium = "playerScrubForwardMedium",
	PLAYER_ScrubForwardLarge = "playerScrubForwardLarge",
	
	TOOLS_CheckTimecodes = "toolsCheckTimecodes",
	TOOLS_OffsetTimecodes = "toolsOffsetTimecodes",
	TOOLS_CheckCEA608 = "toolsCheckCEA608",
	TOOLS_ShowRuler = "toolsShowRuler",
	TOOLS_ShowWaveform = "toolsShowWaveform",
	TOOLS_PresentationMode = "toolsPresentationMode",
	TOOLS_PresentationModeNoCC = "toolsPresentationModeNoCC",
	TOOLS_ConvertToDescriptions = "toolsConvertToDescriptions",
	TOOLS_Preferences = "toolsPreferences",
	
	HELP_CadetHelp = "helpCadetHelp",
	HELP_CadetUserForum = "helpCadetUserForum",
	HELP_KeyboardShortcuts = "helpKeyboardShortcuts",
	HELP_AboutCadet = "helpAboutCadet",
	
	MISC_MoveUpRow = "miscMoveUpRow",
	MISC_MoveDownRow = "miscMoveDownRow",
	MISC_MoveUpRowExtendBlock = "miscMoveUpRowExtendBlock",
	MISC_MoveDownRowExtendBlock = "miscMoveDownRowExtendBlock",
	MISC_ToggleEditReviewMode = "miscToggleEditReviewMode",
	MISC_ToggleCCADMode = "miscToggleCCADMode",
	MISC_ADInsertTimeAsComment = "miscADInsertTimeAsComment",
	MISC_ToggleActivateMenuBar = "miscToggleActivateMenuBar";
	
	

let SKMAP_DEFAULTS = new Map([
	[FILE_NewProject,"Control-J"],
	[FILE_OpenProject,"Control-O"],
	[FILE_SaveProject,"Control-S"],
	[FILE_SaveProjectAs,""],
	[FILE_OpenMedia,"Control-M"],
	[FILE_OpenURL,"Control-Shift-M"],
	[FILE_Import,""],
	[FILE_Export,""],
	[FILE_Quit,"Control-T"],

	[EDIT_CutBlock,"Control-Shift-X"],
	[EDIT_CopyBlock,"Control-Shift-C"],
	[EDIT_PasteBlock,"Control-Shift-V"],
	[EDIT_DeleteBlock,"Control-Shift-L"],
	[EDIT_WrapToRuler,"Control-Shift-3"],
	[EDIT_Find,"Control-Shift-F"],

	[STYLE_Bold,"Control-B"],
	[STYLE_Italic,"Control-I"],
	[STYLE_Underline,"Control-U"],
	[STYLE_MusicalNote,"Control-L"],
	[STYLE_AlignLeft,""],
	[STYLE_AlignCenter,""],
	[STYLE_AlignRight,""],
	[STYLE_AlignTop,""],
	[STYLE_AlignMiddle,""],
	[STYLE_AlignBottom,""],
	[STYLE_TextColorBlack,""],
	[STYLE_TextColorWhite,""],
	[STYLE_TextColorRed,""],
	[STYLE_TextColorBlue,""],
	[STYLE_TextColorGreen,""],
	[STYLE_TextColorYellow,""],
	[STYLE_TextColorCyan,""],
	[STYLE_TextColorMagenta,""],
	[STYLE_BackgroundColorBlack,""],
	[STYLE_BackgroundColorWhite,""],
	[STYLE_BackgroundColorRed,""],
	[STYLE_BackgroundColorBlue,""],
	[STYLE_BackgroundColorGreen,""],
	[STYLE_BackgroundColorYellow,""],
	[STYLE_BackgroundColorCyan,""],
	[STYLE_BackgroundColorMagenta,""],

	[EVENTS_GoToCurrentRow,""],
	[EVENTS_InsertRowBefore,""],
	[EVENTS_InsertRowAfter,""],
	[EVENTS_CombineRowUp,""],
	[EVENTS_DeleteRows,"Control-Shift-BackDelete"],
	[EVENTS_ClearEditor,""],
	[EVENTS_ClearCurrentTimes,""],
	[EVENTS_ClearAllTimes,""],
	[EVENTS_ClearEndTimes,""],
	[EVENTS_InsertStartTime,"Control-Comma"],
	[EVENTS_InsertEndTime,"Control-Period"],

	[PLAYER_PlayPause,"Control-Space"],
	[PLAYER_PlayPauseAD,"Control-Shift-Space"],
	[PLAYER_Stop,"Control-Alt-S"],
	[PLAYER_PlayDirect,"Control-7"],
	[PLAYER_PauseDirect,"Control-6"],
	[PLAYER_CueToStartTime,"Control-Q"],
	[PLAYER_CueToEndTime,"Control-Shift-Q"],
	[PLAYER_SyncToPlayer,"Control-Y"],
	[PLAYER_PlaySlower,"Control-LeftSquareBracket"],
	[PLAYER_PlayFaster,"Control-RightSquareBracket"],
	[PLAYER_PlayNormal,"Control-BackSlash"],
	[PLAYER_ScrubBackSmall,"Control-G"],
	[PLAYER_ScrubBackMedium,"Control-Shift-G"],
	[PLAYER_ScrubBackLarge,"Control-Shift-Alt-G"],
	[PLAYER_ScrubForwardSmall,"Control-H"],
	[PLAYER_ScrubForwardMedium,"Control-Shift-H"],
	[PLAYER_ScrubForwardLarge,"Control-Shift-Alt-H"],

	[TOOLS_CheckTimecodes,""],
	[TOOLS_OffsetTimecodes,""],
	[TOOLS_CheckCEA608,""],
	[TOOLS_ShowRuler,"Control-Shift-R"],
	[TOOLS_ShowWaveform,"Alt-W"],
	[TOOLS_PresentationMode,"Control-N"],
	[TOOLS_PresentationModeNoCC,"Control-Shift-N"],
	[TOOLS_ConvertToDescriptions,""],
	[TOOLS_Preferences,""],

	[HELP_CadetHelp,"F1"],
	[HELP_CadetUserForum,""],
	[HELP_KeyboardShortcuts,"Control-K"],
	[HELP_AboutCadet,""],

	[MISC_MoveUpRow,"Control-UpArrow"],
	[MISC_MoveDownRow,"Control-DownArrow"],
	[MISC_MoveUpRowExtendBlock,"Control-Shift-UpArrow"],
	[MISC_MoveDownRowExtendBlock,"Control-Shift-DownArrow"],
	[MISC_ToggleEditReviewMode,"Control-E"],
	[MISC_ToggleCCADMode,"Control-D"],
	[MISC_ADInsertTimeAsComment,"Control-Shift-Alt-T"],
	[MISC_ToggleActivateMenuBar,"Control-Shift-Alt-M"]

]);


let SKMAP_CURRENTS = new Map([]);
let SKMAP_TRY = new Map([]);

function setCurrentsToDefaults(){
	//SKMAP_DEFAULTS.forEach(copyDefaultsToCurrents);
	SKMAP_DEFAULTS.forEach( function(val, key, map){
		SKMAP_CURRENTS.set(key,val);
	});
}
function copyDefaultsToCurrents(val,key,map){
	map.set(key,val);
}




//Fill up the map of external key strings, keycode and string
/**/
let KSMAP = new Map([
	[8,		"BackDelete"],
	[12,	"NumClear"],
	[13,	"Enter"],
	[20,	"CapsLock"],
	[27,	"Esc"],
	[32,	"Space"],
	[33,	"PageUp"],
	[34,	"PageDown"],
	[35,	"End"],
	[36,	"Home"],
	[37,	"LeftArrow"],
	[38,	"UpArrow"],
	[39,	"RightArrow"],
	[40,	"DownArrow"],
	[46,	"ForwardDelete"],


	[48,	"0"],
	[49,	"1"],
	[50,	"2"],
	[51,	"3"],
	[52,	"4"],
	[53,	"5"],
	[54,	"6"],
	[55,	"7"],
	[56,	"8"],
	[57,	"9"],

	[65,	"A"],
	[66,	"B"],
	[67,	"C"],
	[68,	"D"],
	[69,	"E"],
	[70,	"F"],
	[71,	"G"],
	[72,	"H"],
	[73,	"I"],
	[74,	"J"],
	[75,	"K"],
	[76,	"L"],
	[77,	"M"],
	[78,	"N"],
	[79,	"O"],
	[80,	"P"],
	[81,	"Q"],
	[82,	"R"],
	[83,	"S"],
	[84,	"T"],
	[85,	"U"],
	[86,	"V"],
	[87,	"W"],
	[88,	"X"],
	[89,	"Y"],
	[90,	"Z"],

	[96,	"Num0"],
	[97,	"Num1"],
	[98,	"Num2"],
	[99,	"Num3"],
	[100,	"Num4"],
	[101,	"Num5"],
	[102,	"Num6"],
	[103,	"Num7"],
	[104,	"Num8"],
	[105,	"Num9"],
	[106,	"NumAsterisk"],
	[107,	"NumPlus"],
	[109,	"NumHyphen"],
	[110,	"NumPeriod"],
	[111,	"NumForwardSlash"],


	[112,	"F1"],
	[113,	"F2"],
	[114,	"F3"],
	[115,	"F4"],
	[116,	"F5"],
	[117,	"F6"],
	[118,	"F7"],
	[119,	"F8"],
	[120,	"F9"],
	[121,	"F10"],
	[122,	"F11"],
	[123,	"F12"],
	[124,	"F13"],
	[125,	"F14"],
	[126,	"F15"],
	[127,	"F16"],
	[128,	"F17"],
	[129,	"F18"],
	[130,	"F19"],
	[186,	"Semicolon"],
	[187,	"Equals"],
	[188,	"Comma"],
	[189,	"Hyphen"],
	[190,	"Period"],
	[191,	"ForwardSlash"],
	[192,	"LeftQuote"],
	[219,	"LeftSquareBracket"],
	[220,	"BackSlash"],
	[221,	"RightSquareBracket"],
	[222,	"PlainQuote"]
]);

// These are the short versions for menu display
let KSMAPSHORT = new Map([
	[8,		"⌫"],
	[12,	"Clear"], //was NumClear...
	[13,	"↩"],
	[20,	"⇬"],
	[27,	"Esc"],
	[32,	"␣"],
	[33,	"▲"],
	[34,	"▼"],
	[35,	"End"],
	[36,	"Home"],
	[37,	"←"],
	[38,	"↑"],
	[39,	"→"],
	[40,	"↓"],
	[46,	"⌦"],


	[48,	"0"],
	[49,	"1"],
	[50,	"2"],
	[51,	"3"],
	[52,	"4"],
	[53,	"5"],
	[54,	"6"],
	[55,	"7"],
	[56,	"8"],
	[57,	"9"],

	[65,	"A"],
	[66,	"B"],
	[67,	"C"],
	[68,	"D"],
	[69,	"E"],
	[70,	"F"],
	[71,	"G"],
	[72,	"H"],
	[73,	"I"],
	[74,	"J"],
	[75,	"K"],
	[76,	"L"],
	[77,	"M"],
	[78,	"N"],
	[79,	"O"],
	[80,	"P"],
	[81,	"Q"],
	[82,	"R"],
	[83,	"S"],
	[84,	"T"],
	[85,	"U"],
	[86,	"V"],
	[87,	"W"],
	[88,	"X"],
	[89,	"Y"],
	[90,	"Z"],

	[96,	"Num0"],
	[97,	"Num1"],
	[98,	"Num2"],
	[99,	"Num3"],
	[100,	"Num4"],
	[101,	"Num5"],
	[102,	"Num6"],
	[103,	"Num7"],
	[104,	"Num8"],
	[105,	"Num9"],
	[106,	"NumAsterisk"],
	[107,	"NumPlus"],
	[109,	"NumHyphen"],
	[110,	"NumPeriod"],
	[111,	"NumForwardSlash"],


	[112,	"F1"],
	[113,	"F2"],
	[114,	"F3"],
	[115,	"F4"],
	[116,	"F5"],
	[117,	"F6"],
	[118,	"F7"],
	[119,	"F8"],
	[120,	"F9"],
	[121,	"F10"],
	[122,	"F11"],
	[123,	"F12"],
	[124,	"F13"],
	[125,	"F14"],
	[126,	"F15"],
	[127,	"F16"],
	[128,	"F17"],
	[129,	"F18"],
	[130,	"F19"],
	[186,	";"],
	[187,	"="],
	[188,	","],
	[189,	"-"],
	[190,	"."],
	[191,	"/"],
	[192,	"`"],
	[219,	String.fromCharCode(91)],
	[220,	"\\"],
	[221,	"]"],
	[222,	"'"]
]);

//invert the map for key name lookup to retrieve associated keyval
let KSMAP_R = new Map([
	["BackDelete",	8],
	["NumClear",	12], //on Numeric Keypad area
	["Enter",		13],
	["CapsLock",	20],
	["Esc",			27],
	["Space",		32],
	["PageUp",		33],
	["PageDown",	34],
	["End",			35],
	["Home",		36],
	["LeftArrow",	37],
	["UpArrow",		38],
	["RightArrow",	39],
	["DownArrow",	40],
	["ForwardDelete",46],


	["0",	48],
	["1",	49],
	["2",	50],
	["3",	51],
	["4",	52],
	["5",	53],
	["6",	54],
	["7",	55],
	["8",	56],
	["9",	57],

	["A",	65],
	["B",	66],
	["C",	67],
	["D",	68],
	["E",	69],
	["F",	70],
	["G",	71],
	["H",	72],
	["I",	73],
	["J",	74],
	["K",	75],
	["L",	76],
	["M",	77],
	["N",	78],
	["O",	79],
	["P",	80],
	["Q",	81],
	["R",	82],
	["S",	83],
	["T",	84],
	["U",	85],
	["V",	86],
	["W",	87],
	["X",	88],
	["Y",	89],
	["Z",	90],

	//Num is Numeric Pad section
	["Num0",	96],
	["Num1",	97],
	["Num2",	98],
	["Num3",	99],
	["Num4",	100],
	["Num5",	101],
	["Num6",	102],
	["Num7",	103],
	["Num8",	104],
	["Num9",	105],
	["NumAsterisk",	106],
	["NumPlus",	107],
	["NumHyphen",	109],
	["NumPeriod",	110],
	["NumForwardSlash",	111],


	["F1",	112],
	["F2",	113],
	["F3",	114],
	["F4",	115],
	["F5",	116],
	["F6",	117],
	["F7",	118],
	["F8",	119],
	["F9",	120],
	["F10",	121],
	["F11",	122],
	["F12",	123],
	["F13",	124],
	["F14",	125],
	["F15",	126],
	["F16",	127],
	["F17",	128],
	["F18",	129],
	["F19",	130],
	["Semicolon",	186],
	["Equals",	187],
	["Comma",	188],
	["Hyphen",	189],
	["Period",	190],
	["ForwardSlash",	191],
	["LeftQuote",	192],
	["LeftSquareBracket",	219],
	["BackSlash",	220],
	["RightSquareBracket",	221],
	["PlainQuote",	222]
]);


//This is the normal keyhandler to intercept CADET keystrokes and dispatch
// In CADET, fix the shortcuts handler
function NEWUNUSEDwindowKeyDownHandlerNEWUNUSED(e){ 
	//debug("config.js: windowKeyDownHandler ENTER");
	//create the current keydown key combo
	let kc = new KeyCombo(e.keyCode, e.ctrlKey, e.shiftKey, e.altKey);

	//compare to current skmap until match is found, then execute associated hardwired function
	if( false ){
	//FILE
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_NewProject) ){
		SF_func1();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_OpenProject) ){
		SF_func2();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_SaveProject) ){
		SF_func3();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_SaveProjectAs) ){
		SF_func4();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_OpenMedia) ){
		SF_func5();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_OpenURL) ){
		SF_func6();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_Import) ){
		SF_func7();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_Export) ){
		SF_func8();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(FILE_Quit) ){
		SF_func9();
		e.preventDefault();  
		
	//EDIT
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EDIT_CutBlock) ){
		SF_func10();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EDIT_CopyBlock) ){
		SF_func11();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EDIT_PasteBlock) ){
		SF_func12();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EDIT_DeleteBlock) ){
		SF_func13();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EDIT_WrapToRuler) ){
		SF_func14();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EDIT_Find) ){
		SF_func15();
		e.preventDefault(); 
		
	//STYLE 
	} else if( kc.itoe() == SKMAP_CURRENTS.get(STYLE_Bold) ){
		SF_func16();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(STYLE_Italic) ){
		SF_func17();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(STYLE_Underline) ){
		SF_func18();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(STYLE_MusicalNote) ){
		SF_func19();
		e.preventDefault(); 
		 
	//EVENTS
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_GoToCurrentRow) ){
		SF_func42();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_InsertRowBefore) ){
		SF_func43();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_InsertRowAfter) ){
		SF_func44();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_CombineRowUp) ){
		SF_func45();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_DeleteRows) ){
		SF_func46();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_ClearEditor) ){
		SF_func47();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_ClearCurrentTimes) ){
		SF_func48();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_ClearAllTimes) ){
		SF_func49();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_ClearEndTimes) ){
		SF_func50();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_InsertStartTime) ){
		SF_func51();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(EVENTS_InsertEndTime) ){
		SF_func52();
		e.preventDefault();  
		
	//PLAYER
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_PlayPause) ){
		SF_func53();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_CueToStartTime) ){
		SF_func54();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_CueToEndTime) ){
		SF_func55();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_SyncToPlayer) ){
		SF_func56();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_PlaySlower) ){
		SF_func57();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_PlayFaster) ){
		SF_func58();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_PlayNormal) ){
		SF_func59();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_ScrubBackSmall) ){
		SF_func60();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_ScrubBackMedium) ){
		SF_func61();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_ScrubBackLarge) ){
		SF_func62();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_ScrubForwardSmall) ){
		SF_func63();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_ScrubForwardMedium) ){
		SF_func64();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(PLAYER_ScrubForwardLarge) ){
		SF_func65();
		e.preventDefault(); 
		
	//TOOLS 
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_CheckTimecodes) ){
		SF_func66();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_OffsetTimecodes) ){
		SF_func67();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_CheckCEA608) ){
		SF_func68();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_ShowRuler) ){
		SF_func69();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_ShowWaveform) ){
		SF_func70();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_PresentationMode) ){ //compare the specified key combo
		SF_func71();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_ConvertToDescriptions) ){ //compare the specified key combo
		SF_func72();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(TOOLS_Preferences) ){ //compare the specified key combo
		SF_func73();
		e.preventDefault();  
		
	//HELP
	} else if( kc.itoe() == SKMAP_CURRENTS.get(HELP_CadetHelp) ){ //compare the specified key combo
		SF_func74();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(HELP_CadetUserForum) ){ //compare the specified key combo
		SF_func75();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(HELP_KeyboardShortcuts) ){ //compare the specified key combo
		SF_func76();
		e.preventDefault();  
	} else if( kc.itoe() == SKMAP_CURRENTS.get(HELP_AboutCadet) ){ //compare the specified key combo
		SF_func77();
		e.preventDefault();  
		
	} else {
		console.log("unknown keycombo");
	}
	//debug("windowKeyDownHandler EXIT");
} //windowKeyDownHandler




//SHORTCUT FUNCTIONS (these would be functions that we associate with shortcut keys, like the quit/exit function, etc.)
//FILE
const SF_func1 = func1;
const SF_func2 = func2;
const SF_func3 = func3;
const SF_func4 = func4;
const SF_func5 = func5;
const SF_func6 = func6;
const SF_func7 = func7;
const SF_func8 = func8;
const SF_func9 = func9;
//EDIT
const SF_func10 = func10;
const SF_func11 = func11;
const SF_func12 = func12;
const SF_func13 = func13;
const SF_func14 = func14;
const SF_func15 = func15;
//STYLE
const SF_func16 = func16;
const SF_func17 = func17;
const SF_func18 = func18;
const SF_func19 = func19;
//EVENTS
const SF_func42 = func42;
const SF_func43 = func43;
const SF_func44 = func44;
const SF_func45 = func45;
const SF_func46 = func46;
const SF_func47 = func47;
const SF_func48 = func48;
const SF_func49 = func49;
const SF_func50 = func50;
const SF_func51 = func51;
const SF_func52 = func52;
//PLAYER
const SF_func53 = func53;
const SF_func54 = func54;
const SF_func55 = func55;
const SF_func56 = func56;
const SF_func57 = func57;
const SF_func58 = func58;
const SF_func59 = func59;
const SF_func60 = func60;
const SF_func61 = func61;
const SF_func62 = func62;
const SF_func63 = func63;
const SF_func64 = func64;
const SF_func65 = func65;
//TOOLS
const SF_func66 = func66;
const SF_func67 = func67;
const SF_func68 = func68;
const SF_func69 = func69;
const SF_func70 = func70;
const SF_func71 = func71;
const SF_func72 = func72;
const SF_func73 = func73;
//HELP
const SF_func74 = func74;
const SF_func75 = func75;
const SF_func76 = func76;
const SF_func77 = func77;
const SF_func78 = func78;
const SF_func79 = func79;
const SF_func80 = func80;
const SF_func81 = func81;
const SF_func82 = func82;
const SF_func83 = func83;
const SF_func84 = func84;
const SF_func85 = func85;
const SF_func86 = func86;



//STUB functions for testing
//FILE
function func1(){debug("new project called")};
function func2(){debug("open project called")};
function func3(){debug("save project called")};
function func4(){debug("save project as called")};
function func5(){debug("open media called")};
function func6(){debug("open url called")};
function func7(){debug("import called")};
function func8(){debug("export called")};
function func9(){debug("Quit called")};
//EDIT
function func10(){debug("cut block called")};
function func11(){debug("copy block called")};
function func12(){debug("paste block called")};
function func13(){debug("delete block called")};
function func14(){debug("wrap to ruler called")};
function func15(){debug("find called")};
//STYLE
function func16(){debug("bold called")};
function func17(){debug("italic called")};
function func18(){debug("underline called")};
function func19(){debug("musical note called")};
//EVENTS
function func42(){debug("goto current row called")};
function func43(){debug("insert row before called")};
function func44(){debug("insert row after called")};
function func45(){debug("combine row up called")};
function func46(){debug("delete rows called")};
function func47(){debug("clear editor called")};
function func48(){debug("clear current times called")};
function func49(){debug("clear all times called")};
function func50(){debug("clear end times called")};
function func51(){debug("insert start time called")};
function func52(){debug("insert end time called")};
//PLAYER
function func53(){debug("play/pause called")};
function func54(){debug("play/pause AD called")};
function func55(){debug("cue to start time called")};
function func56(){debug("cue to end time called")};
function func57(){debug("sync to player called")};
function func58(){debug("play slower called")};
function func59(){debug("play faster called")};
function func60(){debug("play normal called")};
function func61(){debug("scrub back small called")};
function func62(){debug("scrub back medium called")};
function func63(){debug("scrub back large called")};
function func64(){debug("scrub forward small called")};
function func65(){debug("scrub forward medium called")};
function func66(){debug("scrub forward large called")};
//TOOLS
function func67(){debug("check timecodes called")};
function func68(){debug("offset timecodes called")};
function func69(){debug("check CEA608 called")};
function func70(){debug("show ruler called")};
function func71(){debug("show waveform called")};
function func72(){debug("presentation mode called")};
function func73(){debug("convert to descriptions called")};
function func74(){debug("preferences called")};
//HELP
function func75(){debug("help called")};
function func76(){debug("user forum called")};
function func77(){debug("shortcuts called")};
function func78(){debug("about called")};
//MISC
function func79(){debug("move up row called")};
function func80(){debug("move down row called")};
function func81(){debug("extend block up called")};
function func82(){debug("extend block down called")};
function func83(){debug("toggle edit/review called")};
function func84(){debug("toggle cc/ad called")};
function func85(){debug("AD insert time as comment called")};
function func86(){debug("activate menu bar called")};


function showShortCutsInMenu(){
	//$("#bmenu1").html("Menu #1"+ (SFKC_func1.itoeShort().length==0 ? "" : "&nbsp;&nbsp;&nbsp;"+SFKC_func1.itoeShort()) );
	let sk=new KeyCombo(); // temp object to use...
	let sfoo1=SKMAP_CURRENTS.get(EVENTS_InsertStartTime);
	sk = sk.etoi(sfoo1);
	let sfoo2=sk.etoi(sfoo1).itoeShort();
	
	//FILE
	$("#m_"+FILE_NewProject+" span.flr").html((SKMAP_CURRENTS.get( FILE_NewProject ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_NewProject ) ).itoeShort());
	$("#m_"+FILE_OpenProject+" span.flr").html((SKMAP_CURRENTS.get( FILE_OpenProject ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_OpenProject ) ).itoeShort());
	$("#m_"+FILE_SaveProject+" span.flr").html((SKMAP_CURRENTS.get( FILE_SaveProject ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_SaveProject ) ).itoeShort());
	$("#m_"+FILE_SaveProjectAs+" span.flr").html((SKMAP_CURRENTS.get( FILE_SaveProjectAs ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_SaveProjectAs ) ).itoeShort());
	$("#m_"+FILE_OpenMedia+" span.flr").html((SKMAP_CURRENTS.get( FILE_OpenMedia ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_OpenMedia ) ).itoeShort());
	$("#m_"+FILE_OpenURL+" span.flr").html((SKMAP_CURRENTS.get( FILE_OpenURL ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_OpenURL ) ).itoeShort());
	$("#m_"+FILE_Import+" span.flr").html((SKMAP_CURRENTS.get( FILE_Import ).length==0) ? "" :sk.etoi( SKMAP_CURRENTS.get( FILE_Import ) ).itoeShort());
	$("#m_"+FILE_Export+" span.flr").html((SKMAP_CURRENTS.get( FILE_Export ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_Export ) ).itoeShort());
	$("#m_"+FILE_Quit+" span.flr").html((SKMAP_CURRENTS.get( FILE_Quit ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( FILE_Quit ) ).itoeShort());
	//EDIT
	$("#m_"+EDIT_CutBlock+" span.flr").html((SKMAP_CURRENTS.get( EDIT_CutBlock ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EDIT_CutBlock ) ).itoeShort());
	$("#m_"+EDIT_CopyBlock+" span.flr").html((SKMAP_CURRENTS.get( EDIT_CopyBlock ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EDIT_CopyBlock ) ).itoeShort());
	$("#m_"+EDIT_PasteBlock+" span.flr").html((SKMAP_CURRENTS.get( EDIT_PasteBlock ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EDIT_PasteBlock ) ).itoeShort());
	$("#m_"+EDIT_DeleteBlock+" span.flr").html((SKMAP_CURRENTS.get( EDIT_DeleteBlock ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EDIT_DeleteBlock ) ).itoeShort());
	$("#m_"+EDIT_WrapToRuler+" span.flr").html((SKMAP_CURRENTS.get( EDIT_WrapToRuler ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EDIT_WrapToRuler ) ).itoeShort());
	$("#m_"+EDIT_Find+" span.flr").html((SKMAP_CURRENTS.get( EDIT_Find ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EDIT_Find ) ).itoeShort());
	//STYLE
	$("#m_"+STYLE_Bold+" span.flr").html((SKMAP_CURRENTS.get( STYLE_Bold ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( STYLE_Bold ) ).itoeShort());
	$("#m_"+STYLE_Italic+" span.flr").html((SKMAP_CURRENTS.get( STYLE_Italic).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( STYLE_Italic ) ).itoeShort());
	$("#m_"+STYLE_Underline+" span.flr").html((SKMAP_CURRENTS.get( STYLE_Underline ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( STYLE_Underline ) ).itoeShort());
	$("#m_"+STYLE_MusicalNote+" span.flr").html((SKMAP_CURRENTS.get( STYLE_MusicalNote ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( STYLE_MusicalNote ) ).itoeShort());
	//EVENTS
	$("#m_"+EVENTS_GoToCurrentRow+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_GoToCurrentRow ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_GoToCurrentRow ) ).itoeShort());
	$("#m_"+EVENTS_InsertRowBefore+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_InsertRowBefore ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_InsertRowBefore ) ).itoeShort());
	$("#m_"+EVENTS_InsertRowAfter+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_InsertRowAfter ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_InsertRowAfter ) ).itoeShort());
	$("#m_"+EVENTS_CombineRowUp+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_CombineRowUp ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_CombineRowUp ) ).itoeShort());
	$("#m_"+EVENTS_DeleteRows+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_DeleteRows ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_DeleteRows ) ).itoeShort());
	$("#m_"+EVENTS_ClearEditor+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_ClearEditor ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_ClearEditor ) ).itoeShort());
	$("#m_"+EVENTS_ClearCurrentTimes+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_ClearCurrentTimes ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_ClearCurrentTimes ) ).itoeShort());
	$("#m_"+EVENTS_ClearAllTimes+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_ClearAllTimes ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_ClearAllTimes ) ).itoeShort());
	$("#m_"+EVENTS_ClearEndTimes+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_ClearEndTimes ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_ClearEndTimes ) ).itoeShort());
	$("#m_"+EVENTS_InsertStartTime+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_InsertStartTime).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_InsertStartTime ) ).itoeShort());
	$("#m_"+EVENTS_InsertEndTime+" span.flr").html((SKMAP_CURRENTS.get( EVENTS_InsertEndTime ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( EVENTS_InsertEndTime ) ).itoeShort());
	//PLAYER
	$("#m_"+PLAYER_PlayPause+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PlayPause ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PlayPause ) ).itoeShort());
	$("#m_"+PLAYER_PlayPauseAD+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PlayPauseAD ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PlayPauseAD ) ).itoeShort());
	$("#m_"+PLAYER_Stop+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_Stop ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_Stop ) ).itoeShort());
	$("#m_"+PLAYER_PlayDirect+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PlayDirect ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PlayDirect ) ).itoeShort());
	$("#m_"+PLAYER_PauseDirect+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PauseDirect ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PauseDirect ) ).itoeShort());
	$("#m_"+PLAYER_CueToStartTime+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_CueToStartTime ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_CueToStartTime ) ).itoeShort());
	$("#m_"+PLAYER_CueToEndTime+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_CueToEndTime ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_CueToEndTime ) ).itoeShort());
	$("#m_"+PLAYER_SyncToPlayer+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_SyncToPlayer ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_SyncToPlayer ) ).itoeShort());
	$("#m_"+PLAYER_PlaySlower+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PlaySlower ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PlaySlower ) ).itoeShort());
	$("#m_"+PLAYER_PlayFaster+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PlayFaster ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PlayFaster ) ).itoeShort());
	$("#m_"+PLAYER_PlayNormal+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_PlayNormal ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_PlayNormal ) ).itoeShort());
	$("#m_"+PLAYER_ScrubBackSmall+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_ScrubBackSmall ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_ScrubBackSmall ) ).itoeShort());
	$("#m_"+PLAYER_ScrubBackMedium+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_ScrubBackMedium ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_ScrubBackMedium ) ).itoeShort());
	$("#m_"+PLAYER_ScrubBackLarge+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_ScrubBackLarge ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_ScrubBackLarge ) ).itoeShort());
	$("#m_"+PLAYER_ScrubForwardSmall+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_ScrubForwardSmall ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_ScrubForwardSmall ) ).itoeShort());
	$("#m_"+PLAYER_ScrubForwardMedium+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_ScrubForwardMedium ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_ScrubForwardMedium ) ).itoeShort());
	$("#m_"+PLAYER_ScrubForwardLarge+" span.flr").html((SKMAP_CURRENTS.get( PLAYER_ScrubForwardLarge ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( PLAYER_ScrubForwardLarge ) ).itoeShort());
	//TOOLS
	$("#m_"+TOOLS_CheckTimecodes+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_CheckTimecodes ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_CheckTimecodes ) ).itoeShort());
	$("#m_"+TOOLS_OffsetTimecodes+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_OffsetTimecodes ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_OffsetTimecodes ) ).itoeShort());
	$("#m_"+TOOLS_CheckCEA608+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_CheckCEA608 ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_CheckCEA608 ) ).itoeShort());
	$("#m_"+TOOLS_ShowRuler+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_ShowRuler ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_ShowRuler ) ).itoeShort());
	$("#m_"+TOOLS_ShowWaveform+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_ShowWaveform ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_ShowWaveform ) ).itoeShort());
	$("#m_"+TOOLS_PresentationMode+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_PresentationMode ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_PresentationMode ) ).itoeShort());
	$("#m_"+TOOLS_PresentationModeNoCC+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_PresentationModeNoCC ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_PresentationModeNoCC ) ).itoeShort());
	$("#m_"+TOOLS_ConvertToDescriptions+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_ConvertToDescriptions ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_ConvertToDescriptions ) ).itoeShort());
	$("#m_"+TOOLS_Preferences+" span.flr").html((SKMAP_CURRENTS.get( TOOLS_Preferences ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( TOOLS_Preferences ) ).itoeShort());
	//HELP
	$("#m_"+HELP_CadetHelp+" span.flr").html((SKMAP_CURRENTS.get( HELP_CadetHelp ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( HELP_CadetHelp ) ).itoeShort());
	$("#m_"+HELP_CadetUserForum+" span.flr").html((SKMAP_CURRENTS.get( HELP_CadetUserForum ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( HELP_CadetUserForum ) ).itoeShort());
	$("#m_"+HELP_KeyboardShortcuts+" span.flr").html((SKMAP_CURRENTS.get( HELP_KeyboardShortcuts ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( HELP_KeyboardShortcuts ) ).itoeShort());
	$("#m_"+HELP_AboutCadet+" span.flr").html((SKMAP_CURRENTS.get( HELP_AboutCadet ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( HELP_AboutCadet ) ).itoeShort());
	//MISC
	$("#m_"+MISC_MoveUpRow+" span.flr").html((SKMAP_CURRENTS.get( MISC_MoveUpRow ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_MoveUpRow ) ).itoeShort());
	$("#m_"+MISC_MoveDownRow+" span.flr").html((SKMAP_CURRENTS.get( MISC_MoveDownRow ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_MoveDownRow ) ).itoeShort());
	$("#m_"+MISC_MoveUpRowExtendBlock+" span.flr").html((SKMAP_CURRENTS.get( MISC_MoveUpRowExtendBlock ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_MoveUpRowExtendBlock ) ).itoeShort());
	$("#m_"+MISC_MoveDownRowExtendBlock+" span.flr").html((SKMAP_CURRENTS.get( MISC_MoveDownRowExtendBlock ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_MoveDownRowExtendBlock ) ).itoeShort());
	$("#m_"+MISC_ToggleEditReviewMode+" span.flr").html((SKMAP_CURRENTS.get( MISC_ToggleEditReviewMode ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_ToggleEditReviewMode ) ).itoeShort());
	$("#m_"+MISC_ToggleCCADMode+" span.flr").html((SKMAP_CURRENTS.get( MISC_ToggleCCADMode ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_ToggleCCADMode ) ).itoeShort());
	$("#m_"+MISC_ADInsertTimeAsComment+" span.flr").html((SKMAP_CURRENTS.get( MISC_ADInsertTimeAsComment ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_ADInsertTimeAsComment ) ).itoeShort());
	$("#m_"+MISC_ToggleActivateMenuBar+" span.flr").html((SKMAP_CURRENTS.get( MISC_ToggleActivateMenuBar ).length==0) ? "" : sk.etoi( SKMAP_CURRENTS.get( MISC_ToggleActivateMenuBar ) ).itoeShort());
}



function areShortcutsOK(){
	//debug("areShortcutsOK called");
	
	//remove all ERROR text from spans
	$(".shortcuterror").text("");
	
	
	//check for collisions, fail if collisions
	grabTableValuesToTry(); //gather html fields into try map
	var scollisions="";
	scollisions = checkForCollisions();
	if( scollisions.length != 0 ){
		collisionAlert(scollisions);
		$("#errorList").html(scollisions);
		prefsTabSet.setSelectedTabToShortcuts(); //this selects the shortcuts tab
		$("#"+firstCollisionId).focus(); //focus the first collision in the list
		return( false );
	} else {
		//save shortcuts here
		saveShortcuts();
		
		
		//update shortcuts in menu
		showShortCutsInMenu();
		
		//restore proper keyhandlerSetShortcut (kill both and just add normal)
		$(".skfield").off("keydown", keyhandlerSetShortcut);
		$(document).off("keydown", __editor.table.windowKeyDownHandler);
		$(document).on("keydown", __editor.table.windowKeyDownHandler);
		
		return( true );
		}
}//areShortcutsOK (ok/save button)

function cancel(){
	debug("canceled called");
	
	//restore proper keyhandlerSetShortcut (kill both and just add normal)
	$(".skfield").off("keydown", keyhandlerSetShortcut);
	$(document).off("keydown", __editor.table.windowKeyDownHandler);
	$(document).on("keydown", __editor.table.windowKeyDownHandler);
	
	//discard shortcuts (do not save)
	hidePrefs();
}//cancel button

//ErrorArray
var errorAccumMap;
var firstCollisionId=""
function checkForCollisions(){
	var sret="";
	errorAccumMap=new Map();//clear the error accumulator map
	tryMapToErrorIdArray();//convert try shortcuts map to array
	firstCollisionId = ""; //reset the firstCollision ID each time
	for (let i=0; i < errorIDArray.length; i++) {
    	const masterlabel=errorIDArray[i].labelID;
    	const mastershortcut=errorIDArray[i].shortcut;
    	if( mastershortcut == "" ) continue;
    	for (let j=i+1; j < errorIDArray.length; j++) {
			const slavelabel=errorIDArray[j].labelID;
			const slaveshortcut=errorIDArray[j].shortcut;
			if( slaveshortcut == "" ) continue;
			
			if( mastershortcut == slaveshortcut ){ //!!! collision !!!
				//add master and slave to map
				errorAccumMap.set(masterlabel,mastershortcut)
				errorAccumMap.set(slavelabel,slaveshortcut)
				//save only the first collision identifier in order to focus
				if(firstCollisionId=="") firstCollisionId = errorIDArray[i].fieldID;
			}
		}//j slave
	}//i master
	
	
	//hardwired...
	//sret="Function #1<br/>Function #2<br/nFunction #3";
	
	//scan the errorAccumMap to create string
	errorAccumMap.forEach(function(value, key, map){
		if( sret.length == 0 ){
			sret = $("#"+key).text().trim() + ": " + value;
		} else {
			sret = sret + ("<br/>" +$("#"+key).text().trim() + ": " + value);
		}
		
		//add ERROR text to span
		let sfoo = "#"+key+" > span"
		$(sfoo).text("CONFLICT");
	
	});
	
	
	//if( sret.length>0) sret = "Shortcut collisions detected:<br/>" + sret;
	return(sret)
}//checkForCollisions

var myAlertDialog=document.querySelector("#collisionAlertDialog");
function collisionAlert(s){
	$("#alertcollisionscontent").html("<h2 id='alertcollisionsheading' tabindex='0'>Collisions detected</h2>"+s);
	myAlertDialog.showModal();
	$("#alertcollisionsheading").focus();
}//collisionAlert
//var myPrefsDialog=document.querySelector("#prefsdialog");
var myPrefsDialog=$("#prefsdialog")[0];
function showPrefs(){
	debug("showPrefs() called");
	
	// Initialize tablist

	  var tablists = document.querySelectorAll('[role=tablist].automatic');
	  for (var i = 0; i < tablists.length; i++) {
		new TabsAutomatic(tablists[i]);
	  }
	
	resetTabs();
	//$("#cadet").addClass("hide");
	//$("#content").removeClass("hide");
	$("#content").css("display", "flex");
	
	//show current Shortcuts new version
	//FILE
	$("#"+FILE_NewProject).text(SKMAP_CURRENTS.get(FILE_NewProject));
	$("#"+FILE_OpenProject).text(SKMAP_CURRENTS.get(FILE_OpenProject));
	$("#"+FILE_SaveProject).text(SKMAP_CURRENTS.get(FILE_SaveProject));
	$("#"+FILE_SaveProjectAs).text(SKMAP_CURRENTS.get(FILE_SaveProjectAs));
	$("#"+FILE_OpenMedia).text(SKMAP_CURRENTS.get(FILE_OpenMedia));
	$("#"+FILE_OpenURL).text(SKMAP_CURRENTS.get(FILE_OpenURL));
	$("#"+FILE_Import).text(SKMAP_CURRENTS.get(FILE_Import));
	$("#"+FILE_Export).text(SKMAP_CURRENTS.get(FILE_Export));
	$("#"+FILE_Quit).text(SKMAP_CURRENTS.get(FILE_Quit));
	//EDIT
	$("#"+EDIT_CutBlock).text(SKMAP_CURRENTS.get(EDIT_CutBlock));
	$("#"+EDIT_CopyBlock).text(SKMAP_CURRENTS.get(EDIT_CopyBlock));
	$("#"+EDIT_PasteBlock).text(SKMAP_CURRENTS.get(EDIT_PasteBlock));
	$("#"+EDIT_DeleteBlock).text(SKMAP_CURRENTS.get(EDIT_DeleteBlock));
	$("#"+EDIT_WrapToRuler).text(SKMAP_CURRENTS.get(EDIT_WrapToRuler));
	$("#"+EDIT_Find).text(SKMAP_CURRENTS.get(EDIT_Find));
	//STYLE
	$("#"+STYLE_Bold).text(SKMAP_CURRENTS.get(STYLE_Bold));
	$("#"+STYLE_Italic).text(SKMAP_CURRENTS.get(STYLE_Italic));
	$("#"+STYLE_Underline).text(SKMAP_CURRENTS.get(STYLE_Underline));
	$("#"+STYLE_MusicalNote).text(SKMAP_CURRENTS.get(STYLE_MusicalNote));
	//EVENTS
	$("#"+EVENTS_GoToCurrentRow).text(SKMAP_CURRENTS.get(EVENTS_GoToCurrentRow));
	$("#"+EVENTS_InsertRowBefore).text(SKMAP_CURRENTS.get(EVENTS_InsertRowBefore));
	$("#"+EVENTS_InsertRowAfter).text(SKMAP_CURRENTS.get(EVENTS_InsertRowAfter));
	$("#"+EVENTS_CombineRowUp).text(SKMAP_CURRENTS.get(EVENTS_CombineRowUp));
	$("#"+EVENTS_DeleteRows).text(SKMAP_CURRENTS.get(EVENTS_DeleteRows));
	$("#"+EVENTS_ClearEditor).text(SKMAP_CURRENTS.get(EVENTS_ClearEditor));
	$("#"+EVENTS_ClearCurrentTimes).text(SKMAP_CURRENTS.get(EVENTS_ClearCurrentTimes));
	$("#"+EVENTS_ClearAllTimes).text(SKMAP_CURRENTS.get(EVENTS_ClearAllTimes));
	$("#"+EVENTS_ClearEndTimes).text(SKMAP_CURRENTS.get(EVENTS_ClearEndTimes));
	$("#"+EVENTS_InsertStartTime).text(SKMAP_CURRENTS.get(EVENTS_InsertStartTime));
	$("#"+EVENTS_InsertEndTime).text(SKMAP_CURRENTS.get(EVENTS_InsertEndTime));
	//PLAYER
	$("#"+PLAYER_PlayPause).text(SKMAP_CURRENTS.get(PLAYER_PlayPause));
	$("#"+PLAYER_PlayPauseAD).text(SKMAP_CURRENTS.get(PLAYER_PlayPauseAD));
	$("#"+PLAYER_Stop).text(SKMAP_CURRENTS.get(PLAYER_Stop));
	$("#"+PLAYER_PlayDirect).text(SKMAP_CURRENTS.get(PLAYER_PlayDirect));
	$("#"+PLAYER_PauseDirect).text(SKMAP_CURRENTS.get(PLAYER_PauseDirect));
	$("#"+PLAYER_CueToStartTime).text(SKMAP_CURRENTS.get(PLAYER_CueToStartTime));
	$("#"+PLAYER_CueToEndTime).text(SKMAP_CURRENTS.get(PLAYER_CueToEndTime));
	$("#"+PLAYER_SyncToPlayer).text(SKMAP_CURRENTS.get(PLAYER_SyncToPlayer));
	$("#"+PLAYER_PlaySlower).text(SKMAP_CURRENTS.get(PLAYER_PlaySlower));
	$("#"+PLAYER_PlayFaster).text(SKMAP_CURRENTS.get(PLAYER_PlayFaster));
	$("#"+PLAYER_PlayNormal).text(SKMAP_CURRENTS.get(PLAYER_PlayNormal));
	$("#"+PLAYER_ScrubBackSmall).text(SKMAP_CURRENTS.get(PLAYER_ScrubBackSmall));
	$("#"+PLAYER_ScrubBackMedium).text(SKMAP_CURRENTS.get(PLAYER_ScrubBackMedium));
	$("#"+PLAYER_ScrubBackLarge).text(SKMAP_CURRENTS.get(PLAYER_ScrubBackLarge));
	$("#"+PLAYER_ScrubForwardSmall).text(SKMAP_CURRENTS.get(PLAYER_ScrubForwardSmall));
	$("#"+PLAYER_ScrubForwardMedium).text(SKMAP_CURRENTS.get(PLAYER_ScrubForwardMedium));
	$("#"+PLAYER_ScrubForwardLarge).text(SKMAP_CURRENTS.get(PLAYER_ScrubForwardLarge));
	//TOOLS
	$("#"+TOOLS_CheckTimecodes).text(SKMAP_CURRENTS.get(TOOLS_CheckTimecodes));
	$("#"+TOOLS_OffsetTimecodes).text(SKMAP_CURRENTS.get(TOOLS_OffsetTimecodes));
	$("#"+TOOLS_CheckCEA608).text(SKMAP_CURRENTS.get(TOOLS_CheckCEA608));
	$("#"+TOOLS_ShowRuler).text(SKMAP_CURRENTS.get(TOOLS_ShowRuler));
	$("#"+TOOLS_ShowWaveform).text(SKMAP_CURRENTS.get(TOOLS_ShowWaveform));
	$("#"+TOOLS_PresentationMode).text(SKMAP_CURRENTS.get(TOOLS_PresentationMode));
	$("#"+TOOLS_PresentationModeNoCC).text(SKMAP_CURRENTS.get(TOOLS_PresentationModeNoCC));
	$("#"+TOOLS_ConvertToDescriptions).text(SKMAP_CURRENTS.get(TOOLS_ConvertToDescriptions));
	//HELP
	$("#"+HELP_CadetHelp).text(SKMAP_CURRENTS.get(HELP_CadetHelp));
	$("#"+HELP_CadetUserForum).text(SKMAP_CURRENTS.get(HELP_CadetUserForum));
	$("#"+HELP_KeyboardShortcuts).text(SKMAP_CURRENTS.get(HELP_KeyboardShortcuts));
	//MISC
	$("#"+MISC_MoveUpRow).text(SKMAP_CURRENTS.get(MISC_MoveUpRow));
	$("#"+MISC_MoveDownRow).text(SKMAP_CURRENTS.get(MISC_MoveDownRow));
	$("#"+MISC_MoveUpRowExtendBlock).text(SKMAP_CURRENTS.get(MISC_MoveUpRowExtendBlock));
	$("#"+MISC_MoveDownRowExtendBlock).text(SKMAP_CURRENTS.get(MISC_MoveDownRowExtendBlock));
	$("#"+MISC_ToggleEditReviewMode).text(SKMAP_CURRENTS.get(MISC_ToggleEditReviewMode));
	$("#"+MISC_ToggleCCADMode).text(SKMAP_CURRENTS.get(MISC_ToggleCCADMode));
	$("#"+MISC_ADInsertTimeAsComment).text(SKMAP_CURRENTS.get(MISC_ADInsertTimeAsComment));
	$("#"+MISC_ToggleActivateMenuBar).text(SKMAP_CURRENTS.get(MISC_ToggleActivateMenuBar));
	
	myPrefsDialog.showModal();
	
}//showPrefs

function showCurrentShortcuts(){
	//debug("showCurrentShortcuts() called");
	
	//show current Shortcuts new version
	//FILE
	$("#"+FILE_NewProject).text(SKMAP_CURRENTS.get(FILE_NewProject));
	$("#"+FILE_OpenProject).text(SKMAP_CURRENTS.get(FILE_OpenProject));
	$("#"+FILE_SaveProject).text(SKMAP_CURRENTS.get(FILE_SaveProject));
	$("#"+FILE_SaveProjectAs).text(SKMAP_CURRENTS.get(FILE_SaveProjectAs));
	$("#"+FILE_OpenMedia).text(SKMAP_CURRENTS.get(FILE_OpenMedia));
	$("#"+FILE_OpenURL).text(SKMAP_CURRENTS.get(FILE_OpenURL));
	$("#"+FILE_Import).text(SKMAP_CURRENTS.get(FILE_Import));
	$("#"+FILE_Export).text(SKMAP_CURRENTS.get(FILE_Export));
	$("#"+FILE_Quit).text(SKMAP_CURRENTS.get(FILE_Quit));
	//EDIT
	$("#"+EDIT_CutBlock).text(SKMAP_CURRENTS.get(EDIT_CutBlock));
	$("#"+EDIT_CopyBlock).text(SKMAP_CURRENTS.get(EDIT_CopyBlock));
	$("#"+EDIT_PasteBlock).text(SKMAP_CURRENTS.get(EDIT_PasteBlock));
	$("#"+EDIT_DeleteBlock).text(SKMAP_CURRENTS.get(EDIT_DeleteBlock));
	$("#"+EDIT_WrapToRuler).text(SKMAP_CURRENTS.get(EDIT_WrapToRuler));
	$("#"+EDIT_Find).text(SKMAP_CURRENTS.get(EDIT_Find));
	//STYLE
	$("#"+STYLE_Bold).text(SKMAP_CURRENTS.get(STYLE_Bold));
	$("#"+STYLE_Italic).text(SKMAP_CURRENTS.get(STYLE_Italic));
	$("#"+STYLE_Underline).text(SKMAP_CURRENTS.get(STYLE_Underline));
	$("#"+STYLE_MusicalNote).text(SKMAP_CURRENTS.get(STYLE_MusicalNote));
	//EVENTS
	$("#"+EVENTS_GoToCurrentRow).text(SKMAP_CURRENTS.get(EVENTS_GoToCurrentRow));
	$("#"+EVENTS_InsertRowBefore).text(SKMAP_CURRENTS.get(EVENTS_InsertRowBefore));
	$("#"+EVENTS_InsertRowAfter).text(SKMAP_CURRENTS.get(EVENTS_InsertRowAfter));
	$("#"+EVENTS_CombineRowUp).text(SKMAP_CURRENTS.get(EVENTS_CombineRowUp));
	$("#"+EVENTS_DeleteRows).text(SKMAP_CURRENTS.get(EVENTS_DeleteRows));
	$("#"+EVENTS_ClearEditor).text(SKMAP_CURRENTS.get(EVENTS_ClearEditor));
	$("#"+EVENTS_ClearCurrentTimes).text(SKMAP_CURRENTS.get(EVENTS_ClearCurrentTimes));
	$("#"+EVENTS_ClearAllTimes).text(SKMAP_CURRENTS.get(EVENTS_ClearAllTimes));
	$("#"+EVENTS_ClearEndTimes).text(SKMAP_CURRENTS.get(EVENTS_ClearEndTimes));
	$("#"+EVENTS_InsertStartTime).text(SKMAP_CURRENTS.get(EVENTS_InsertStartTime));
	$("#"+EVENTS_InsertEndTime).text(SKMAP_CURRENTS.get(EVENTS_InsertEndTime));
	//PLAYER
	$("#"+PLAYER_PlayPause).text(SKMAP_CURRENTS.get(PLAYER_PlayPause));
	$("#"+PLAYER_PlayPauseAD).text(SKMAP_CURRENTS.get(PLAYER_PlayPauseAD));
	$("#"+PLAYER_Stop).text(SKMAP_CURRENTS.get(PLAYER_Stop));
	$("#"+PLAYER_PlayDirect).text(SKMAP_CURRENTS.get(PLAYER_PlayDirect));
	$("#"+PLAYER_PauseDirect).text(SKMAP_CURRENTS.get(PLAYER_PauseDirect));
	$("#"+PLAYER_CueToStartTime).text(SKMAP_CURRENTS.get(PLAYER_CueToStartTime));
	$("#"+PLAYER_CueToEndTime).text(SKMAP_CURRENTS.get(PLAYER_CueToEndTime));
	$("#"+PLAYER_SyncToPlayer).text(SKMAP_CURRENTS.get(PLAYER_SyncToPlayer));
	$("#"+PLAYER_PlaySlower).text(SKMAP_CURRENTS.get(PLAYER_PlaySlower));
	$("#"+PLAYER_PlayFaster).text(SKMAP_CURRENTS.get(PLAYER_PlayFaster));
	$("#"+PLAYER_PlayNormal).text(SKMAP_CURRENTS.get(PLAYER_PlayNormal));
	$("#"+PLAYER_ScrubBackSmall).text(SKMAP_CURRENTS.get(PLAYER_ScrubBackSmall));
	$("#"+PLAYER_ScrubBackMedium).text(SKMAP_CURRENTS.get(PLAYER_ScrubBackMedium));
	$("#"+PLAYER_ScrubBackLarge).text(SKMAP_CURRENTS.get(PLAYER_ScrubBackLarge));
	$("#"+PLAYER_ScrubForwardSmall).text(SKMAP_CURRENTS.get(PLAYER_ScrubForwardSmall));
	$("#"+PLAYER_ScrubForwardMedium).text(SKMAP_CURRENTS.get(PLAYER_ScrubForwardMedium));
	$("#"+PLAYER_ScrubForwardLarge).text(SKMAP_CURRENTS.get(PLAYER_ScrubForwardLarge));
	//TOOLS
	$("#"+TOOLS_CheckTimecodes).text(SKMAP_CURRENTS.get(TOOLS_CheckTimecodes));
	$("#"+TOOLS_OffsetTimecodes).text(SKMAP_CURRENTS.get(TOOLS_OffsetTimecodes));
	$("#"+TOOLS_CheckCEA608).text(SKMAP_CURRENTS.get(TOOLS_CheckCEA608));
	$("#"+TOOLS_ShowRuler).text(SKMAP_CURRENTS.get(TOOLS_ShowRuler));
	$("#"+TOOLS_ShowWaveform).text(SKMAP_CURRENTS.get(TOOLS_ShowWaveform));
	$("#"+TOOLS_PresentationMode).text(SKMAP_CURRENTS.get(TOOLS_PresentationMode));
	$("#"+TOOLS_PresentationModeNoCC).text(SKMAP_CURRENTS.get(TOOLS_PresentationModeNoCC));
	$("#"+TOOLS_ConvertToDescriptions).text(SKMAP_CURRENTS.get(TOOLS_ConvertToDescriptions));
	//HELP
	$("#"+HELP_CadetHelp).text(SKMAP_CURRENTS.get(HELP_CadetHelp));
	$("#"+HELP_CadetUserForum).text(SKMAP_CURRENTS.get(HELP_CadetUserForum));
	$("#"+HELP_KeyboardShortcuts).text(SKMAP_CURRENTS.get(HELP_KeyboardShortcuts));
	//MISC
	$("#"+MISC_MoveUpRow).text(SKMAP_CURRENTS.get(MISC_MoveUpRow));
	$("#"+MISC_MoveDownRow).text(SKMAP_CURRENTS.get(MISC_MoveDownRow));
	$("#"+MISC_MoveUpRowExtendBlock).text(SKMAP_CURRENTS.get(MISC_MoveUpRowExtendBlock));
	$("#"+MISC_MoveDownRowExtendBlock).text(SKMAP_CURRENTS.get(MISC_MoveDownRowExtendBlock));
	$("#"+MISC_ToggleEditReviewMode).text(SKMAP_CURRENTS.get(MISC_ToggleEditReviewMode));
	$("#"+MISC_ToggleCCADMode).text(SKMAP_CURRENTS.get(MISC_ToggleCCADMode));
	$("#"+MISC_ADInsertTimeAsComment).text(SKMAP_CURRENTS.get(MISC_ADInsertTimeAsComment));
	$("#"+MISC_ToggleActivateMenuBar).text(SKMAP_CURRENTS.get(MISC_ToggleActivateMenuBar));
} //showCurrentShortcuts

function hidePrefs(){
	debug("hidePrefs() called");
	//$("#content").addClass("hide");
	//$("#cadet").removeClass("hide");
	$("#mymodal")[0].close();
}//hidePrefs

function saveShortcuts(){
	//debug("ABORTED saveShortcuts");
	//return;
	//debug("saveShortcuts called");
	grabTableValues();
	//mapExternSaved = JSON.stringify(Array.from(SFMAP.entries())); //save serialized version
	//debug(mapExternSaved);
}//saveShortcuts

function loadShortcuts(){
	debug("ABORTED loadShortcuts");
	return;
	var log = document.getElementById('log');
	mapExternSaved = log.value;
	SFMAP = new Map(JSON.parse(mapExternSaved)); //save serialized version
	//now push to widgets...
	
}//loadShortcuts
function resetShortcuts(){
	debug("ABORTED resetShortcuts");
	return;
	SFMAP = new Map(JSON.parse(mapExternOrig)); //load original values
	//now push to  widgets
}//resetShortcuts

function grabTableValues(){
	//grab each one save to CURRENTS (really save)
	//FILE
	SKMAP_CURRENTS.set(FILE_NewProject, $("#"+FILE_NewProject).text());
	SKMAP_CURRENTS.set(FILE_OpenProject, $("#"+FILE_OpenProject).text());
	SKMAP_CURRENTS.set(FILE_SaveProject, $("#"+FILE_SaveProject).text());
	SKMAP_CURRENTS.set(FILE_SaveProjectAs, $("#"+FILE_SaveProjectAs).text());
	SKMAP_CURRENTS.set(FILE_OpenMedia, $("#"+FILE_OpenMedia).text());
	SKMAP_CURRENTS.set(FILE_OpenURL, $("#"+FILE_OpenURL).text());
	SKMAP_CURRENTS.set(FILE_Import, $("#"+FILE_Import).text());
	SKMAP_CURRENTS.set(FILE_Export, $("#"+FILE_Export).text());
	SKMAP_CURRENTS.set(FILE_Quit, $("#"+FILE_Quit).text());
	//EDIT
	SKMAP_CURRENTS.set(EDIT_CutBlock, $("#"+EDIT_CutBlock).text());
	SKMAP_CURRENTS.set(EDIT_CopyBlock, $("#"+EDIT_CopyBlock).text());
	SKMAP_CURRENTS.set(EDIT_PasteBlock, $("#"+EDIT_PasteBlock).text());
	SKMAP_CURRENTS.set(EDIT_DeleteBlock, $("#"+EDIT_DeleteBlock).text());
	SKMAP_CURRENTS.set(EDIT_WrapToRuler, $("#"+EDIT_WrapToRuler).text());
	SKMAP_CURRENTS.set(EDIT_Find, $("#"+EDIT_Find).text());
	//STyLE
	SKMAP_CURRENTS.set(STYLE_Bold, $("#"+STYLE_Bold).text());
	SKMAP_CURRENTS.set(STYLE_Italic, $("#"+STYLE_Italic).text());
	SKMAP_CURRENTS.set(STYLE_Underline, $("#"+STYLE_Underline).text());
	SKMAP_CURRENTS.set(STYLE_MusicalNote, $("#"+STYLE_MusicalNote).text());
	//EVENTS
	SKMAP_CURRENTS.set(EVENTS_GoToCurrentRow, $("#"+EVENTS_GoToCurrentRow).text());
	SKMAP_CURRENTS.set(EVENTS_InsertRowBefore, $("#"+EVENTS_InsertRowBefore).text());
	SKMAP_CURRENTS.set(EVENTS_InsertRowAfter, $("#"+EVENTS_InsertRowAfter).text());
	SKMAP_CURRENTS.set(EVENTS_CombineRowUp, $("#"+EVENTS_CombineRowUp).text());
	SKMAP_CURRENTS.set(EVENTS_DeleteRows, $("#"+EVENTS_DeleteRows).text());
	SKMAP_CURRENTS.set(EVENTS_ClearEditor, $("#"+EVENTS_ClearEditor).text());
	SKMAP_CURRENTS.set(EVENTS_ClearCurrentTimes, $("#"+EVENTS_ClearCurrentTimes).text());
	SKMAP_CURRENTS.set(EVENTS_ClearAllTimes, $("#"+EVENTS_ClearAllTimes).text());
	SKMAP_CURRENTS.set(EVENTS_ClearEndTimes, $("#"+EVENTS_ClearEndTimes).text());
	SKMAP_CURRENTS.set(EVENTS_InsertStartTime, $("#"+EVENTS_InsertStartTime).text());
	SKMAP_CURRENTS.set(EVENTS_InsertEndTime, $("#"+EVENTS_InsertEndTime).text());
	//PLAYER
	SKMAP_CURRENTS.set(PLAYER_PlayPause, $("#"+PLAYER_PlayPause).text());
	SKMAP_CURRENTS.set(PLAYER_PlayPauseAD, $("#"+PLAYER_PlayPauseAD).text());
	SKMAP_CURRENTS.set(PLAYER_Stop, $("#"+PLAYER_Stop).text());
	SKMAP_CURRENTS.set(PLAYER_PlayDirect, $("#"+PLAYER_PlayDirect).text());
	SKMAP_CURRENTS.set(PLAYER_PauseDirect, $("#"+PLAYER_PauseDirect).text());
	SKMAP_CURRENTS.set(PLAYER_CueToStartTime, $("#"+PLAYER_CueToStartTime).text());
	SKMAP_CURRENTS.set(PLAYER_CueToEndTime, $("#"+PLAYER_CueToEndTime).text());
	SKMAP_CURRENTS.set(PLAYER_SyncToPlayer, $("#"+PLAYER_SyncToPlayer).text());
	SKMAP_CURRENTS.set(PLAYER_PlaySlower, $("#"+PLAYER_PlaySlower).text());
	SKMAP_CURRENTS.set(PLAYER_PlayFaster, $("#"+PLAYER_PlayFaster).text());
	SKMAP_CURRENTS.set(PLAYER_PlayNormal, $("#"+PLAYER_PlayNormal).text());
	SKMAP_CURRENTS.set(PLAYER_ScrubBackSmall, $("#"+PLAYER_ScrubBackSmall).text());
	SKMAP_CURRENTS.set(PLAYER_ScrubBackMedium, $("#"+PLAYER_ScrubBackMedium).text());
	SKMAP_CURRENTS.set(PLAYER_ScrubBackLarge, $("#"+PLAYER_ScrubBackLarge).text());
	SKMAP_CURRENTS.set(PLAYER_ScrubForwardSmall, $("#"+PLAYER_ScrubForwardSmall).text());
	SKMAP_CURRENTS.set(PLAYER_ScrubForwardMedium, $("#"+PLAYER_ScrubForwardMedium).text());
	SKMAP_CURRENTS.set(PLAYER_ScrubForwardLarge, $("#"+PLAYER_ScrubForwardLarge).text());
	//TOOLS
	SKMAP_CURRENTS.set(TOOLS_CheckTimecodes, $("#"+TOOLS_CheckTimecodes).text());
	SKMAP_CURRENTS.set(TOOLS_OffsetTimecodes, $("#"+TOOLS_OffsetTimecodes).text());
	SKMAP_CURRENTS.set(TOOLS_CheckCEA608, $("#"+TOOLS_CheckCEA608).text());
	SKMAP_CURRENTS.set(TOOLS_ShowRuler, $("#"+TOOLS_ShowRuler).text());
	SKMAP_CURRENTS.set(TOOLS_ShowWaveform, $("#"+TOOLS_ShowWaveform).text());
	SKMAP_CURRENTS.set(TOOLS_PresentationMode, $("#"+TOOLS_PresentationMode).text());
	SKMAP_CURRENTS.set(TOOLS_PresentationModeNoCC, $("#"+TOOLS_PresentationModeNoCC).text());
	SKMAP_CURRENTS.set(TOOLS_ConvertToDescriptions, $("#"+TOOLS_ConvertToDescriptions).text());
	//HELP
	SKMAP_CURRENTS.set(HELP_CadetHelp, $("#"+HELP_CadetHelp).text());
	SKMAP_CURRENTS.set(HELP_CadetUserForum, $("#"+HELP_CadetUserForum).text());
	SKMAP_CURRENTS.set(HELP_KeyboardShortcuts, $("#"+HELP_KeyboardShortcuts).text());
	SKMAP_CURRENTS.set(HELP_AboutCadet, $("#"+HELP_AboutCadet).text());
	//MISC
	SKMAP_CURRENTS.set(MISC_MoveUpRow, $("#"+MISC_MoveUpRow).text());
	SKMAP_CURRENTS.set(MISC_MoveDownRow, $("#"+MISC_MoveDownRow).text());
	SKMAP_CURRENTS.set(MISC_MoveUpRowExtendBlock, $("#"+MISC_MoveUpRowExtendBlock).text());
	SKMAP_CURRENTS.set(MISC_MoveDownRowExtendBlock, $("#"+MISC_MoveDownRowExtendBlock).text());
	SKMAP_CURRENTS.set(MISC_ToggleEditReviewMode, $("#"+MISC_ToggleEditReviewMode).text());
	SKMAP_CURRENTS.set(MISC_ToggleCCADMode, $("#"+MISC_ToggleCCADMode).text());
	SKMAP_CURRENTS.set(MISC_ADInsertTimeAsComment, $("#"+MISC_ADInsertTimeAsComment).text());
	SKMAP_CURRENTS.set(MISC_ToggleActivateMenuBar, $("#"+MISC_ToggleActivateMenuBar).text());
}
function grabTableValuesToTry(){
	//grab each one save to test
	SKMAP_TRY.clear();
	//FILE
	SKMAP_TRY.set(FILE_NewProject, $("#"+FILE_NewProject).text());
	SKMAP_TRY.set(FILE_OpenProject, $("#"+FILE_OpenProject).text());
	SKMAP_TRY.set(FILE_SaveProject, $("#"+FILE_SaveProject).text());
	SKMAP_TRY.set(FILE_SaveProjectAs, $("#"+FILE_SaveProjectAs).text());
	SKMAP_TRY.set(FILE_OpenMedia, $("#"+FILE_OpenMedia).text());
	SKMAP_TRY.set(FILE_OpenURL, $("#"+FILE_OpenURL).text());
	SKMAP_TRY.set(FILE_Import, $("#"+FILE_Import).text());
	SKMAP_TRY.set(FILE_Export, $("#"+FILE_Export).text());
	SKMAP_TRY.set(FILE_Quit, $("#"+FILE_Quit).text());
	//EDIT
	SKMAP_TRY.set(EDIT_CutBlock, $("#"+EDIT_CutBlock).text());
	SKMAP_TRY.set(EDIT_CopyBlock, $("#"+EDIT_CopyBlock).text());
	SKMAP_TRY.set(EDIT_PasteBlock, $("#"+EDIT_PasteBlock).text());
	SKMAP_TRY.set(EDIT_DeleteBlock, $("#"+EDIT_DeleteBlock).text());
	SKMAP_TRY.set(EDIT_WrapToRuler, $("#"+EDIT_WrapToRuler).text());
	SKMAP_TRY.set(EDIT_Find, $("#"+EDIT_Find).text());
	//STyLE
	SKMAP_TRY.set(STYLE_Bold, $("#"+STYLE_Bold).text());
	SKMAP_TRY.set(STYLE_Italic, $("#"+STYLE_Italic).text());
	SKMAP_TRY.set(STYLE_Underline, $("#"+STYLE_Underline).text());
	SKMAP_TRY.set(STYLE_MusicalNote, $("#"+STYLE_MusicalNote).text());
	//EVENTS
	SKMAP_TRY.set(EVENTS_GoToCurrentRow, $("#"+EVENTS_GoToCurrentRow).text());
	SKMAP_TRY.set(EVENTS_InsertRowBefore, $("#"+EVENTS_InsertRowBefore).text());
	SKMAP_TRY.set(EVENTS_InsertRowAfter, $("#"+EVENTS_InsertRowAfter).text());
	SKMAP_TRY.set(EVENTS_CombineRowUp, $("#"+EVENTS_CombineRowUp).text());
	SKMAP_TRY.set(EVENTS_DeleteRows, $("#"+EVENTS_DeleteRows).text());
	SKMAP_TRY.set(EVENTS_ClearEditor, $("#"+EVENTS_ClearEditor).text());
	SKMAP_TRY.set(EVENTS_ClearCurrentTimes, $("#"+EVENTS_ClearCurrentTimes).text());
	SKMAP_TRY.set(EVENTS_ClearAllTimes, $("#"+EVENTS_ClearAllTimes).text());
	SKMAP_TRY.set(EVENTS_ClearEndTimes, $("#"+EVENTS_ClearEndTimes).text());
	SKMAP_TRY.set(EVENTS_InsertStartTime, $("#"+EVENTS_InsertStartTime).text());
	SKMAP_TRY.set(EVENTS_InsertEndTime, $("#"+EVENTS_InsertEndTime).text());
	//PLAYER
	SKMAP_TRY.set(PLAYER_PlayPause, $("#"+PLAYER_PlayPause).text());
	SKMAP_TRY.set(PLAYER_PlayPauseAD, $("#"+PLAYER_PlayPauseAD).text());
	SKMAP_TRY.set(PLAYER_Stop, $("#"+PLAYER_Stop).text());
	SKMAP_TRY.set(PLAYER_PlayDirect, $("#"+PLAYER_PlayDirect).text());
	SKMAP_TRY.set(PLAYER_PauseDirect, $("#"+PLAYER_PauseDirect).text());
	SKMAP_TRY.set(PLAYER_CueToStartTime, $("#"+PLAYER_CueToStartTime).text());
	SKMAP_TRY.set(PLAYER_CueToEndTime, $("#"+PLAYER_CueToEndTime).text());
	SKMAP_TRY.set(PLAYER_SyncToPlayer, $("#"+PLAYER_SyncToPlayer).text());
	SKMAP_TRY.set(PLAYER_PlaySlower, $("#"+PLAYER_PlaySlower).text());
	SKMAP_TRY.set(PLAYER_PlayFaster, $("#"+PLAYER_PlayFaster).text());
	SKMAP_TRY.set(PLAYER_PlayNormal, $("#"+PLAYER_PlayNormal).text());
	SKMAP_TRY.set(PLAYER_ScrubBackSmall, $("#"+PLAYER_ScrubBackSmall).text());
	SKMAP_TRY.set(PLAYER_ScrubBackMedium, $("#"+PLAYER_ScrubBackMedium).text());
	SKMAP_TRY.set(PLAYER_ScrubBackLarge, $("#"+PLAYER_ScrubBackLarge).text());
	SKMAP_TRY.set(PLAYER_ScrubForwardSmall, $("#"+PLAYER_ScrubForwardSmall).text());
	SKMAP_TRY.set(PLAYER_ScrubForwardMedium, $("#"+PLAYER_ScrubForwardMedium).text());
	SKMAP_TRY.set(PLAYER_ScrubForwardLarge, $("#"+PLAYER_ScrubForwardLarge).text());
	//TOOLS
	SKMAP_TRY.set(TOOLS_CheckTimecodes, $("#"+TOOLS_CheckTimecodes).text());
	SKMAP_TRY.set(TOOLS_OffsetTimecodes, $("#"+TOOLS_OffsetTimecodes).text());
	SKMAP_TRY.set(TOOLS_CheckCEA608, $("#"+TOOLS_CheckCEA608).text());
	SKMAP_TRY.set(TOOLS_ShowRuler, $("#"+TOOLS_ShowRuler).text());
	SKMAP_TRY.set(TOOLS_ShowWaveform, $("#"+TOOLS_ShowWaveform).text());
	SKMAP_TRY.set(TOOLS_PresentationMode, $("#"+TOOLS_PresentationMode).text());
	SKMAP_TRY.set(TOOLS_PresentationModeNoCC, $("#"+TOOLS_PresentationModeNoCC).text());
	SKMAP_TRY.set(TOOLS_ConvertToDescriptions, $("#"+TOOLS_ConvertToDescriptions).text());
	//HELP
	SKMAP_TRY.set(HELP_CadetHelp, $("#"+HELP_CadetHelp).text());
	SKMAP_TRY.set(HELP_CadetUserForum, $("#"+HELP_CadetUserForum).text());
	SKMAP_TRY.set(HELP_KeyboardShortcuts, $("#"+HELP_KeyboardShortcuts).text());
	SKMAP_TRY.set(HELP_AboutCadet, $("#"+HELP_AboutCadet).text());
	//MISC
	SKMAP_TRY.set(MISC_MoveUpRow, $("#"+MISC_MoveUpRow).text());
	SKMAP_TRY.set(MISC_MoveDownRow, $("#"+MISC_MoveDownRow).text());
	SKMAP_TRY.set(MISC_MoveUpRowExtendBlock, $("#"+MISC_MoveUpRowExtendBlock).text());
	SKMAP_TRY.set(MISC_MoveDownRowExtendBlock, $("#"+MISC_MoveDownRowExtendBlock).text());
	SKMAP_TRY.set(MISC_ToggleEditReviewMode, $("#"+MISC_ToggleEditReviewMode).text());
	SKMAP_TRY.set(MISC_ToggleCCADMode, $("#"+MISC_ToggleCCADMode).text());
	SKMAP_TRY.set(MISC_ADInsertTimeAsComment, $("#"+MISC_ADInsertTimeAsComment).text());
	SKMAP_TRY.set(MISC_ToggleActivateMenuBar, $("#"+MISC_ToggleActivateMenuBar).text());
}


//////////////////////////////////////////
function foo(){
	//debug("hello world");
	var sfoo;
	mapExternSaved = JSON.stringify(Array.from(SFMAP.entries()));
	debug(mapExternSaved);
	
}
/*
function dolog(s){
	var log = document.getElementById('log');
	log.value += s;
	log.value += "\n";
	log.scrollTop = log.scrollHeight;
}
function clearlog(){
	var log = $("#log")[0];//document.getElementById('log');
	log.value = "";
}
*/


/*
 *   This content is licensed according to the W3C Software License at
 *   https://www.w3.org/Consortium/Legal/2015/copyright-software-and-document
 *
 *   File:   tabs-automatic.js
 *
 *   Desc:   Tablist widget that implements ARIA Authoring Practices
 */

//'use strict';

class TabsAutomatic {
  constructor(groupNode) {
    this.tablistNode = groupNode;

    this.tabs = [];

    this.firstTab = null;
    this.lastTab = null;
    this.prefsTab = null;

    this.tabs = Array.from(this.tablistNode.querySelectorAll('[role=tab]'));
    this.tabpanels = [];

    for (var i = 0; i < this.tabs.length; i += 1) {
      var tab = this.tabs[i];
      var tabpanel = document.getElementById(tab.getAttribute('aria-controls'));

      tab.tabIndex = -1;
      tab.setAttribute('aria-selected', 'false');
      this.tabpanels.push(tabpanel);

      tab.addEventListener('keydown', this.onKeydown.bind(this));
      tab.addEventListener('click', this.onClick.bind(this));

      if (!this.firstTab) {
        this.firstTab = tab;
      }
      this.lastTab = tab;
    }

    this.setSelectedTab(this.firstTab, false);
    
    this.prefsTab = this.lastTab;
  }
  
  
  setSelectedTab(currentTab, setFocus) {
    //debug("setSelectedTab() ENTER")
    if (typeof setFocus !== 'boolean') {
      setFocus = true;
    }
    for (var i = 0; i < this.tabs.length; i += 1) {
      var tab = this.tabs[i];
      if (currentTab === tab) {
        tab.setAttribute('aria-selected', 'true');
        tab.removeAttribute('tabindex');
        this.tabpanels[i].classList.remove('is-hidden');
        if (setFocus) {
          tab.focus();
        }
        
    	//debug("REMOVE normal keydown handler, ADD keydown handler for setting shortcuts");
		$(document).off("keydown", __editor.table.windowKeyDownHandler);
		$(".skfield").off("keydown", keyhandlerSetShortcut);
		$(".skfield").on("keydown", keyhandlerSetShortcut);
        
      } else {
        tab.setAttribute('aria-selected', 'false');
        tab.tabIndex = -1;
        this.tabpanels[i].classList.add('is-hidden');

    	//debug("REMOVE keydown handler for setting shortcuts, ADD normal keydown handler");
		$(".skfield").off("keydown", keyhandlerSetShortcut);
		$(document).off("keydown", __editor.table.windowKeyDownHandler);
		$(document).on("keydown", __editor.table.windowKeyDownHandler);

      }      
    }
  }
  
  setSelectedTabToShortcuts(){
	this.setSelectedTab(this.prefsTab, true);
  }


  setSelectedToPreviousTab(currentTab) {
    var index;

    if (currentTab === this.firstTab) {
      this.setSelectedTab(this.lastTab);
    } else {
      index = this.tabs.indexOf(currentTab);
      this.setSelectedTab(this.tabs[index - 1]);
    }
  }

  setSelectedToNextTab(currentTab) {
    var index;

    if (currentTab === this.lastTab) {
      this.setSelectedTab(this.firstTab);
    } else {
      index = this.tabs.indexOf(currentTab);
      this.setSelectedTab(this.tabs[index + 1]);
    }
  }

  /* EVENT HANDLERS */

  onKeydown(event) {
    var tgt = event.currentTarget,
      flag = false;

    switch (event.key) {
      case 'ArrowLeft':
        this.setSelectedToPreviousTab(tgt);
        flag = true;
        break;

      case 'ArrowRight':
        this.setSelectedToNextTab(tgt);
        flag = true;
        break;

      case 'Home':
        this.setSelectedTab(this.firstTab);
        flag = true;
        break;

      case 'End':
        this.setSelectedTab(this.lastTab);
        flag = true;
        break;

      default:
        break;
    }

    if (flag) {
      event.stopPropagation();
      event.preventDefault();
    }
  }

  onClick(event) {
    this.setSelectedTab(event.currentTarget);
  }
}

//create array of objects from the current map, encapsulating function labels and settings
let errorIDArray = [];
function tryMapToErrorIdArray(){
	//const values = [];
	//const keys = [];
	errorIDArray = []; //clear existing values
	let icount=0;
	SKMAP_TRY.forEach((value, key) => {
		//values.push(value);
		//keys.push(key);
		errorIDArray.push({"index":icount, "labelID":"label_"+key, "fieldID":key, "shortcut":value})
		icount++;
	});
	//console.log(keys);
	//console.log(values);
	//console.log("key[3]=",keys[3], "val[3]=", values[3]);
	console.log("errorIDMap=",errorIDArray);
}



/////// DOCUMENT READY EVENT ///////////
// Initialize tablist and such
$().ready( function(){
	//tab list
	var tablists = document.querySelectorAll('[role=tablist].automatic');
	for (var i = 0; i < tablists.length; i++) {
		new TabsAutomatic(tablists[i]);
	}
	
	//button handlers for unset and set default in table
	$(".unsetButton").click(function(e){
		var prevTD = $(this).closest('td').prev();
		prevTD.children().text("");
	})
	$(".setDefaultButton").click(function(e){
		var prevTD = $(this).closest('td').prev().prev(); //2 td's back
		var sfoo="", sfoo2="";
		sfoo = (prevTD.children())[0];
		sfoo2 = sfoo.id;
		setShortcutField(sfoo2);
	})
	
	
});
/////// DOCUMENT READY EVENT ///////////

//TO DO
/*



-DONE - focus SHORTCUTS TAB and first offender if collision detected after "Save"
-DONE - defeat unadorned alphaNumericPunctuation keys
-DONE - defeat unadorned arrow keys
-DONE - duplicate the OK/Cancel pair at top, to right of "Preferences" dialog title as skip link
-DONE - fix page size/scrolling behavior
-DONE - remove horizontal scroll bar in shortcut table
-DONE - Perhaps attached to OK/SAVE button:
-DONE   - check for collisions 
-DONE   - show collisions in alert
-DONE   - show collisions in collision area of shortcut div
-DONE   - focus the shortcuts tab and the first offending shortcut
-DONE - change OK (of Cancel/OK) to Save
-DONE - There’s nothing in the General preferences pane yet, that’s just a placeholder for the current preferences
-DONE - Not sure about the shortcuts instructions, should that be a field of some sort. It’s currently just in the text of the element
-DONE - yes, I was wondering about table navigation with arrow keys. I was reading about Voiceover table navigation, I’ll see what I can do
-DONE - I should probably make the shortcut field aria-live=“polite”
-DONE - Turn the first column into headers
*/
